# -*- coding: utf-8 -*-
"""
Created on Fri Apr 20 10:53:29 2018

@author: Callie Darseu

Call Wenjing's Gabor
"""

import cv2
import os
import subprocess
import numpy as np

def locate_window(title):
    '''
    This function places the window for openCV
    
    '''
    
    move_window = [0, -30]
    cv2.namedWindow(title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
    cv2.moveWindow(title, move_window[0], move_window[1]) 
    
def stitch(left, right, frame):
    '''
    
    
    
    '''
    
    assert left.shape[0] == left.shape[1]
    assert right.shape[0] == right.shape[1]
    assert left.shape[0] == right.shape[0]
    
    rows, cols, channels = frame.shape
    
    side, side, ch = left.shape
    
    left = cv2.resize(left, (rows, rows))
    right = cv2.resize(right, (rows, rows))
    
    print('left.shape:', left.shape)
    print('right.shape:', right.shape)
    
    stitched = np.zeros_like(frame)
    
    stitched[:, 0:rows, :] = left
    
    print('', stitched[:, rows:, :].shape)
    print('', right[:, rows - (cols - rows):, :].shape)
    
    
    stitched[:, rows:, :] = right[:, rows - (cols - rows):, :]
    
    stitched_resized = cv2.resize(stitched, (int(side * cols / rows), side))
    frame_resized = cv2.resize(frame, (int(side * cols / rows), side))
    
    return stitched, stitched_resized, frame_resized
    


common = "./video_copies_clips_track/copies_and_clips_facilitator_C/"
specific = "STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__200_208/PNGs/"
name = "MVI_0028_trans__200_208_0036.png"

assemble = common + specific + "AM_FM_by_Wenjing/"
if not os.path.isdir(assemble):
    os.mkdir(assemble)

frame = cv2.imread(common + specific + name)

rows, cols, channels = frame.shape

frame_left, frame_right = frame[:, 0: rows, :], frame[:, -rows:, :]

print('frame_left.shape', frame_left.shape)
print('frame_right.shape', frame_right.shape)

#title='left'; locate_window(title); cv2.imshow(title, frame_left)
#title='right'; locate_window(title); cv2.imshow(title, frame_right)

cv2.imwrite(assemble + name[0:-3]+'left.png', frame_left)
cv2.imwrite(assemble + name[0:-3]+'right.png', frame_right)

file_left = assemble + name[0:-3]+'left.png'
file_right = assemble + name[0:-3]+'right.png'

executable = "../VisualStudio/Gabor_by_Wenjing_Shi/x64/Release/Gabor_by_Wenjing_Shi.exe"
subprocess.call([executable, file_left])
subprocess.call([executable, file_right])

file_mag_left = assemble + name[0:-3] + 'left.mag.png'
file_phas_left = assemble + name[0:-3] + 'left.phas.png'

file_mag_right = assemble + name[0:-3] + 'right.mag.png'
file_phas_right = assemble + name[0:-3] + 'right.phas.png'

mag_left = cv2.imread(file_mag_left)
phas_left = cv2.imread(file_phas_left)

mag_right = cv2.imread(file_mag_right)
phas_right = cv2.imread(file_phas_right) 

stitched_mag, stitched_resize_mag, frame_resized = \
    stitch(mag_left, mag_right, frame)
stitched_phas, stitched_resize_phas, frame_resized = \
    stitch(phas_left, phas_right, frame)

title='mag'; locate_window(title); cv2.imshow(title, stitched_mag)
title='phas'; locate_window(title); cv2.imshow(title, stitched_phas)

file_mag = assemble + name[0:-3] + '.mag.png'
file_phas = assemble + name[0:-3] + '.phas.png'

file_mag_resized = assemble + name[0:-3] + '.mag.png'
file_phas_resized = assemble + name[0:-3] + '.phas.png'

file_frame_resized = assemble + name[0:-3] + 'resized.png'

cv2.imwrite(file_mag, stitched_mag)
cv2.imwrite(file_phas, stitched_phas)

cv2.imwrite(file_mag_resized, stitched_resize_mag)
cv2.imwrite(file_phas_resized, stitched_resize_phas)

cv2.imwrite(file_frame_resized, frame_resized)

cv2.waitKey(0)
cv2.destroyAllWindows()
