# -*- coding: utf-8 -*-
"""
Created on Wed May  9 23:26:55 2018

@author: Callie Darsey
"""

import numpy as np
import cv2

dim=(500, 800, 3)

I = np.zeros(dim, dtype=np.uint8)

patch_row_1 = 120
patch_row_2 = 390
patch_col_1 = 50
patch_col_2 = 480

exemplar_row_1 = 340
exemplar_row_2 = 440
exemplar_col_1 = 10
exemplar_col_2 = 80

cv2.rectangle(I, (patch_col_1, patch_row_1),
              (patch_col_2, patch_row_2),
              (255, 0, 0), 1)

cv2.rectangle(I, (exemplar_col_1, exemplar_row_1),
              (exemplar_col_2, exemplar_row_2),
              (0, 255, 0), 1)

e1 = cv2.getTickCount()

# rows
if not (patch_row_2 < exemplar_row_1 or patch_row_1 > exemplar_row_2):
    
    row_1 = np.max([patch_row_1, exemplar_row_1])
    row_2 = np.min([patch_row_2, exemplar_row_2])

# cols    
if not (patch_col_2 < exemplar_col_1 or patch_col_1 > exemplar_col_2):
    
    col_1 = np.max([patch_col_1, exemplar_col_1])
    col_2 = np.min([patch_col_2, exemplar_col_2])
    
print((row_2 - row_1 + 1) * (col_2 - col_1 + 1))
    
e2 = cv2.getTickCount()
time = (e2 - e1)/ cv2.getTickFrequency()
print("Execution time in seconds = ", time)


e1 = cv2.getTickCount()

patch = np.zeros(dim[0:2], dtype=np.uint8)

exemplar = np.zeros(dim[0:2], dtype=np.uint8)

patch[patch_row_1 : patch_row_2 + 1,
      patch_col_1 : patch_col_2 + 1] = 255
      
exemplar[exemplar_row_1 : exemplar_row_2 + 1,
         exemplar_col_1 : exemplar_col_2 + 1] = 255
         
print(np.count_nonzero(np.logical_and(patch, exemplar)))
    
e2 = cv2.getTickCount()
time = (e2 - e1)/ cv2.getTickFrequency()
print("Execution time in seconds = ", time)


cv2.imshow('rectangles', I)
cv2.waitKey(0)
cv2.destroyAllWindows()