# -*- coding: utf-8 -*-
"""
Created on Thu Feb 22 12:16:06 2018

@author: Callie Darsey

Exploring histogram creation

exploring_histogram_creation_01

"""

import cv2
import numpy as np

def print_one_channel_image(image):
    
    for row in image:
        s = ''
        for element in row:
            s = s + '{:3d}'.format(element) + ', '
        print(s)
    print('')
    
def print_one_channel_image_as_float(image):
    
    for row in image:
        s = ''
        for element in row:
            s = s + '{:4.2f}'.format(element) + ', '
        print(s)
    print('')
    
def print_row(row_array):
    s = ''
    for element in row_array:
        s = s + '{:3d}, '.format(element)
    print(s)
    print('')
    
def print_one_dim_elements(one_dim_array):
    s = ''
    for element in one_dim_array:
        s = s + '{:4.2f}, '.format(element)
    print(s)
    print('')    

if __name__ == '__main__':
    
    I = cv2.imread('50264881_00101_0107_Medium.jpg')
    
    print('I.shape', I.shape, '\n')
    
    row_start = 130
    height = 6
    
    col_start = 107
    width = 6
    
    image = I[row_start:row_start + height, col_start:col_start + width, :]
    
    print_one_channel_image(image[:, :, 0])
    print_one_channel_image(image[:, :, 1])
    print_one_channel_image(image[:, :, 2])
