# -*- coding: utf-8 -*-
"""
Created on Tue May  8 17:46:28 2018

@author: Callie Darsey

features_from_reference_try_mag_wheeler_01
"""

import cv2
import numpy as np
import pickle
import matplotlib.pyplot as plt
import os


def get_seg_mag_sum(segment_flow_mag):
    '''
    '''
    collect = []
    
    for flow_mag_display in segment_flow_mag:
        
        collect.append(flow_mag_display[:, :, 0].astype(np.float64))
        
    segment_sum = \
        (np.sum(collect, axis=0) / len(segment_flow_mag)).astype(np.uint8)
        
    segment_sum_display = \
        np.stack([segment_sum, segment_sum, segment_sum], axis=2)
        
    return segment_sum_display

def function():
    directory = "./"
    
    for content in os.listdir(directory):
        
        print(content)
        
        if os.path.isfile(directory + content):
            
            if content[-12:] == '.sampled.mp4':
                
                name = content[:-12]
                
                break
                                       
    cap_flow_mag = cv2.VideoCapture(directory+'flow_'+name+'.flow_mag.mp4')
    cap_flow_ang = cv2.VideoCapture(directory+'flow_'+name+'.flow_ang.mp4')
    
    
    with open(directory + 'exemplars_and_labels___' + name + '.data',
              'rb') as f:
        
        exemplars_and_labels = pickle.load(f)
        
    exemplar_info = {}
    
    keys = np.array(list(exemplars_and_labels.keys()))
    
    
    segment = 45
    
    segment_flow_mag = []
    segment_flow_ang = []
    
    count = -1
    ind = -1
                
    set_size = (28, 28)
    
    while(cap_flow_mag.isOpened() and cap_flow_ang.isOpened()):
        
        success_flag_flow_mag, flow_mag_display = cap_flow_mag.read()
        success_flag_flow_ang, flow_ang_display = cap_flow_ang.read()
        
        if success_flag_flow_mag == True and success_flag_flow_ang == True:
            
            count = count + 1
    
            segment_flow_mag.append(flow_mag_display)
            segment_flow_ang.append(flow_ang_display)
        
            if len(segment_flow_mag) > segment:
                segment_flow_mag.pop(0)
                segment_flow_ang.pop(0)
    
            else:
                ind = ind + 1
    
            if count != 0 and (count + 1) % segment == 0:
                
                flow_mag_sum = get_seg_mag_sum(segment_flow_mag)
                
                print('segment', int(np.floor(count / segment)))
                
                index = np.where(keys[:, 1] == count * 4)[0]
                
                if len(index) == 1:
                    
                    exemplars, tags = \
                        exemplars_and_labels[(keys[index[0], 0],
                                              keys[index[0], 1])]
                        
                    feature_vectors = np.zeros((exemplars.shape[0],
                                                set_size[0] * set_size[1]))
                    
                    for i, box in enumerate(exemplars):
                        
                        col_1, row_1, col_2, row_2 = box
                        
                        crop = flow_mag_sum[row_1 : row_2 + 1,
                                            col_1 : col_2 + 1, 0]
                        
                        rows, cols = crop.shape
                        
                        if rows == cols:
                            pad = crop
                            
                        elif rows > cols:
                            pad = np.zeros((rows, rows))
                            shift = int((rows - cols) / 2)
                            pad[ :, shift : shift + cols] = crop
                            
                        elif cols > rows:
                            pad = np.zeros((cols, cols))
                            shift = int((cols - rows) / 2)
                            pad[ shift : shift + rows, :] = crop
                        
                        pad = cv2.resize(pad, set_size)
    
                        feature_vectors[i] =  pad.ravel()   
                        
                    exemplar_info[(keys[index[0], 0], keys[index[0], 1])] = \
                        [exemplars, tags, feature_vectors]
              
        else:
            
            print("No more frames")
            
            cap_flow_mag.release()
            cap_flow_ang.release()
                    
            break        
    else:
        
        cap_flow_mag.release()
        cap_flow_ang.release()
    
    with open(directory + \
              'exemplars_labels_and_flow_mag_sum_feature_vectors' + \
              '_{:d}x{:d}___'.format(set_size[0], set_size[1]) + \
              name + '.data', 'wb') as f:
        
        pickle.dump((exemplar_info), f)   