# -*- coding: utf-8 -*-
"""
Created on Fri May 11 16:44:37 2018

@author: Callie Darsey

first_patch_LOO_attempt_01
"""

import pickle
import numpy as np
import sklearn.ensemble as ske
import sklearn.metrics as skmet
import sklearn.neighbors as skn
import sklearn.linear_model as sklm


upper = './wheeler/dataset/'
tag = 'patches_labels_and_features___'

clip_info = [\
upper + 'part1/MVI_0069_trans/' + tag + 'MVI_0069_trans__0_100.data',
upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag + 'MVI_0039_trans__460_563.data',
upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag + 'MVI_0073_trans__0_100.data',
upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag + 'MVI_0074_trans__240_342.data',
upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag + 'MVI_0087_trans__579_680.data',
upper + 'STI_Polk_May11_C/MVI_0108_trans/' + tag + 'MVI_0108_trans__0_42.data',
upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag + 'MVI_0036_trans__870_912.data',
upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag + 'MVI_0018_trans__910_954.data',
upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag + 'MVI_0070_trans__670_712.data',
upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag + 'MVI_0029_trans__515_557.data',
upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag + 'MVI_0118_trans__100_142.data',
upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag + 'MVI_0112_trans__15_57.data',
upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag + 'MVI_0053_trans__0_100.data',
upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag + 'MVI_0074_trans__60_102.data',
upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag + 'MVI_0109_trans__0_42.data']

segment = 45

# holds head and hand feature vectors per clip
head_feature_vectors_per_clip = []
hand_feature_vectors_per_clip = []
non_exemplar_feature_vectors_per_clip = []

#ftype = 'feature of patch location'
ftype = 'sum all flow mag.'
for clip in clip_info:
    
    with open(clip, 'rb') as f:
        
        patches_info = pickle.load(f)

    head_clip = []
    hand_clip = []
    non_exemplar_clip = []
        
    for info in patches_info.values():
        
        patches, tags, feature_location, feature_sum_all_flow_mag = info
        
        tags_ar = np.array(tags)
        
        
        # group according to tags
        head_indices = np.where(np.any([tags_ar == 'predominately head',
                                        tags_ar == 'predominately both'],
                                       axis=0))[0]
        
        hand_indices = np.where(tags_ar == 'predominately hand')[0]
        
        non_exemplar_indices = \
            np.where(tags_ar == 'predominately non-exemplar')[0]
        
        # feature location
        if len(head_indices) > 0:
            head_clip.append(feature_sum_all_flow_mag[head_indices, :])
            
        if len(hand_indices) > 0:
            hand_clip.append(feature_sum_all_flow_mag[hand_indices, :])
            
        if len(non_exemplar_indices) > 0:
            non_exemplar_clip.append(\
                feature_sum_all_flow_mag[non_exemplar_indices, :])

        # complete flow mag. sum over patch clip
        

            
    # stack for clip
    head_clip = np.vstack(head_clip)
    hand_clip = np.vstack(hand_clip)
    non_exemplar_clip = np.vstack(non_exemplar_clip)
    
    # collect per clip
    head_feature_vectors_per_clip.append(head_clip)
    hand_feature_vectors_per_clip.append(hand_clip)
    non_exemplar_feature_vectors_per_clip.append(non_exemplar_clip)

indices = np.arange(len(clip_info))

accuracy_collect = []
precision_collect = []
recall_collect = []
f1_collect = []

print('')

for i in indices:
    
    val_test_index = i
    train_indices = np.where(indices != i)[0]
    
    train_head = head_feature_vectors_per_clip.copy()
    train_hand = hand_feature_vectors_per_clip.copy()
    train_non_exemplar = non_exemplar_feature_vectors_per_clip.copy()
    
    val_test_head = train_head.pop(i)
    val_test_hand = train_hand.pop(i)
    val_test_non_exemplar = train_non_exemplar.pop(i)
    
    # stack    
    train_head = np.vstack(train_head)
    train_hand = np.vstack(train_hand)
    train_non_exemplar = np.vstack(train_non_exemplar)
    
    X = np.vstack([train_head, train_hand, train_non_exemplar])
    
    print('X.shape', X.shape, ' ('
          'train_head.shape', train_head.shape,
          'train_hand.shape', train_hand.shape,
          'train_non_exemplar.shape', train_non_exemplar.shape, ')')
        
    X_LOO = np.vstack([val_test_head, val_test_hand, val_test_non_exemplar])
    
    # 0 for non-exemplar, 1 for head, 2 for hand
    y_train = np.hstack([np.zeros(len(train_non_exemplar)),
                         np.ones(len(train_head)),
                         np.ones(len(train_hand)) * 2])
            
    y_val = np.hstack([np.zeros(len(val_test_non_exemplar)),
                       np.ones(len(val_test_head)),
                       np.ones(len(val_test_hand)) * 2])

    # random forest classifier
    n_estimators = 100
    
    param_distributions = {'n_estimators' : [10, 50, 100, 200, 500, 1000],
                       'criterion' : ['gini'],
              
                       'max_features' : ['sqrt', 'log2', None, 1, 4, 0.25],
                       'max_depth' : [None, 5, 50, 190],
              
                       'min_samples_split' : [2, 10, 100],
                       'min_samples_leaf' : [1, 20, 400],
                       'min_weight_fraction_leaf' : [0.0, 0.01, 0.1],

                       'max_leaf_nodes' : [None, 70, 10, 2],
              
                       'min_impurity_split' : [0.0000001,
                                               0.00001,
                                               0.001],
                       'bootstrap' : [True],
                       'oob_score' : [True],
                       'n_jobs' : [-1],
                       'random_state' : [None],
                       'verbose' : [1],
                       'warm_start' : [False],
                       'class_weight' : [None, 'balanced_subsample']}  

    rf_clf = ske.RandomForestClassifier(n_estimators=n_estimators)
#                                       max_features='sqrt',
#                                       max_depth=70,
#                                       max_leaf_nodes=200,
#                                       min_samples_split=6)
#                                        min_samples_leaf=10,
#                                        min_weight_fraction_leaf=0.5,
#                                        min_impurity_split=0.01)
#    
    knn_clf = skn.KNeighborsClassifier(51)
    
    log_reg = sklm.LogisticRegression()
        
    # train
    log_reg.fit(X, y_train)
    
    # leave-one-out test
    print('X_LOO.shape', X_LOO.shape, ' (',
          'val_test_non_exemplar.shape', val_test_non_exemplar.shape,
          'val_test_head.shape', val_test_head.shape,
          'val_test_hand.shape', val_test_hand.shape, ')')
    
    y_predicted = log_reg.predict(X_LOO)

    # report
    accuracy = skmet.accuracy_score(y_val, y_predicted)
    precision = skmet.precision_score(y_val, y_predicted, labels=[0, 1, 2],
                                      average=None)
    recall = skmet.recall_score(y_val, y_predicted, labels=[0, 1, 2],
                                average=None)
    f1 = skmet.f1_score(y_val, y_predicted, labels=[0, 1, 2], average=None)
    
    accuracy_collect.append(accuracy)
    precision_collect.append(precision)
    recall_collect.append(recall)
    f1_collect.append(f1)
    
    header_row    = '           non-exemplar     head          hand     '
    precision_row = 'Precision  {:12.3f}  {:12.3f}  {:12.3f}'
    recall_row    = 'Recall     {:12.3f}  {:12.3f}  {:12.3f}'
    f1_row        = 'F1 score   {:12.3f}  {:12.3f}  {:12.3f}'
    accuracy_row  = 'Accuracy  {:12.3f}'
    
    print(accuracy_row.format(accuracy))
    print('confusion matrix:\n', skmet.confusion_matrix(y_val, y_predicted))
    print(header_row)
    print(precision_row.format(precision[0], precision[1], precision[2]))
    print(recall_row.format(recall[0], recall[1], recall[2]))
    print(f1_row.format(f1[0], f1[1], f1[2]))


print('tag:', tag)
print('n_estimators:', n_estimators)
print(ftype)



#print('Accuracy: ',
#      'min {:.2f}, median {:.2f}, mean {:.2f}, max {:.2f}'.format(\
#           np.min(accuracy_collect),
#           np.median(accuracy_collect),
#           np.mean(accuracy_collect),
#           np.max(accuracy_collect)))      
#    
#print('Precision:',
#      'min {:.2f}, median {:.2f}, mean {:.2f}, max {:.2f}'.format(\
#           np.min(precision_collect),
#           np.median(precision_collect),
#           np.mean(precision_collect),
#           np.max(precision_collect)))    
#
#print('Recall   :',
#      'min {:.2f}, median {:.2f}, mean {:.2f}, max {:.2f}'.format(\
#           np.min(recall_collect),
#           np.median(recall_collect),
#           np.mean(recall_collect),
#           np.max(recall_collect)))  
