# -*- coding: utf-8 -*-
"""
Created on Tue May  8 02:21:24 2018

@author: Callie Darsey

leave one out and first attempt with classification

first_reference_LOO_attempt_01
"""

import pickle
import numpy as np
import sklearn.ensemble as ske
import sklearn.metrics as skmet
import sklearn.neighbors as skn
import sklearn.linear_model as sklm

bins = 32

upper = './wheeler/dataset/'
tag1 = 'exemplars_and_labels_and_feature_vectors_{:d}___'.format(bins)
tag2 = 'exemplars_labels_and_flow_mag_sum_feature_vectors_28x28___'
tag3 = 'exemplars_labels_and_stuff_as_feature_vectors_100x100___'

clip_info1 = [\
upper + 'part1/MVI_0069_trans/' + tag1 + 'MVI_0069_trans__0_100.data',
upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag1 + 'MVI_0039_trans__460_563.data',
upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag1 + 'MVI_0073_trans__0_100.data',
upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag1 + 'MVI_0074_trans__240_342.data',
upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag1 + 'MVI_0087_trans__579_680.data',
upper + 'STI_Polk_May11_C/MVI_0108_trans/' +tag1 + 'MVI_0108_trans__0_42.data',
upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag1 + 'MVI_0036_trans__870_912.data',
upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag1 + 'MVI_0018_trans__910_954.data',
upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag1 + 'MVI_0070_trans__670_712.data',
upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag1 + 'MVI_0029_trans__515_557.data',
upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag1 + 'MVI_0118_trans__100_142.data',
upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag1 + 'MVI_0112_trans__15_57.data',
upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag1 + 'MVI_0053_trans__0_100.data',
upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag1 + 'MVI_0074_trans__60_102.data',
upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag1 + 'MVI_0109_trans__0_42.data']

clip_info2 = [\
upper + 'part1/MVI_0069_trans/' + tag2 + 'MVI_0069_trans__0_100.data',
upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag2 + 'MVI_0039_trans__460_563.data',
upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag2 + 'MVI_0073_trans__0_100.data',
upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag2 + 'MVI_0074_trans__240_342.data',
upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag2 + 'MVI_0087_trans__579_680.data',
upper + 'STI_Polk_May11_C/MVI_0108_trans/' +tag2 + 'MVI_0108_trans__0_42.data',
upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag2 + 'MVI_0036_trans__870_912.data',
upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag2 + 'MVI_0018_trans__910_954.data',
upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag2 + 'MVI_0070_trans__670_712.data',
upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag2 + 'MVI_0029_trans__515_557.data',
upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag2 + 'MVI_0118_trans__100_142.data',
upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag2 + 'MVI_0112_trans__15_57.data',
upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag2 + 'MVI_0053_trans__0_100.data',
upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag2 + 'MVI_0074_trans__60_102.data',
upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag2 + 'MVI_0109_trans__0_42.data']

clip_info3 = [\
upper + 'part1/MVI_0069_trans/' + tag3 + 'MVI_0069_trans__0_100.data',
upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag3 + 'MVI_0039_trans__460_563.data',
upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag3 + 'MVI_0073_trans__0_100.data',
upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag3 + 'MVI_0074_trans__240_342.data',
upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag3 + 'MVI_0087_trans__579_680.data',
upper + 'STI_Polk_May11_C/MVI_0108_trans/' +tag3 + 'MVI_0108_trans__0_42.data',
upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag3 + 'MVI_0036_trans__870_912.data',
upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag3 + 'MVI_0018_trans__910_954.data',
upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag3 + 'MVI_0070_trans__670_712.data',
upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag3 + 'MVI_0029_trans__515_557.data',
upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag3 + 'MVI_0118_trans__100_142.data',
upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag3 + 'MVI_0112_trans__15_57.data',
upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag3 + 'MVI_0053_trans__0_100.data',
upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag3 + 'MVI_0074_trans__60_102.data',
upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag3 + 'MVI_0109_trans__0_42.data']

segment = 45

# holds head and hand feature vectors per clip
head_feature_vectors_per_clip = []
hand_feature_vectors_per_clip = []

#ftype = 'histogram of flow - no summation over 45 frames'
#ftype = 'flow mag sum over 45 frames'
#ftype = 'histogram of flow - no summation over 45 frames and \n' + \
#        'flow mag sum over 45 frames'
ftype = 'overlaid skin detection over 45 frames'
for clip1, clip3 in zip(clip_info1, clip_info3):
    
    with open(clip1, 'rb') as f:
        
        exemplar_info1 = pickle.load(f)

#    with open(clip2, 'rb') as f:
#        
#        exemplar_info2 = pickle.load(f)        

    with open(clip3, 'rb') as f:
        
        exemplar_info3 = pickle.load(f) 
        
    head_clip = []
    hand_clip = []
        
#    for info1, info2 in zip(exemplar_info1.values(), exemplar_info2.values()):
    for info1, info3 in zip(exemplar_info1.values(), exemplar_info3.values()):
        
        exemplar, tags, features1 = info1
        
#        exemplar, tags, features2 = info2
#        
#        ftype = 'histogram of flow - summation over 45 frames'
#        
#        ftype = 'histogram of flow - summation over 45 frames and \n' + \
#                'flow mag sum over 45 frames'

        exemplar, tags, features3 = info3

        features1 = np.reshape(features1, (features1.shape[0], segment, bins))
        
        features1 = np.sum(features1, axis=1)
        
        ftype = 'histogram of flow - summation over 45 frames\n' + \
                'and overlaid skin detection over 45 frames'
        
        tags_ar = np.array(tags)
        
        head_indices = np.where(np.any([tags_ar == 'predominately head',
                                        tags_ar == 'predominately both'],
                                       axis=0))[0]
        
        hand_indices = np.where(tags_ar == 'predominately hand')[0]
        
#        if len(head_indices) > 0:
#            head_clip.append(np.hstack([features1[head_indices, :],
#                                        features2[head_indices, :]]))
#            
#        if len(hand_indices) > 0:
#            hand_clip.append(np.hstack([features1[hand_indices, :],
#                                        features2[hand_indices, :]]))

#        if len(head_indices) > 0:
#            head_clip.append(np.hstack([features3[head_indices, :]]))
#            
#        if len(hand_indices) > 0:
#            hand_clip.append(np.hstack([features3[hand_indices, :]]))

        if len(head_indices) > 0:
            head_clip.append(np.hstack([features1[head_indices, :],
                                        features3[head_indices, :]]))
            
        if len(hand_indices) > 0:
            hand_clip.append(np.hstack([features1[hand_indices, :],
                                        features3[hand_indices, :]]))


            
    # stack for clip
    head_clip = np.vstack(head_clip)
    hand_clip = np.vstack(hand_clip)
    
    # collect per clip
    head_feature_vectors_per_clip.append(head_clip)
    hand_feature_vectors_per_clip.append(hand_clip)


indices = np.arange(len(clip_info1))

accuracy_collect = []
precision_collect = []
recall_collect = []

print('')

for i in indices:
    
    val_test_index = i
    train_indices = np.where(indices != i)[0]
    
    train_head = head_feature_vectors_per_clip.copy()
    train_hand = hand_feature_vectors_per_clip.copy()
    
    val_test_head = train_head.pop(i)
    val_test_hand = train_hand.pop(i)
    
    # stack    
    train_head = np.vstack(train_head)
    train_hand = np.vstack(train_hand)
    
    X = np.vstack([train_head, train_hand])
    
    print('X.shape', X.shape, ' ('
          'train_head.shape', train_head.shape,
          'train_hand.shape', train_hand.shape, ')')
        
    X_LOO = np.vstack([val_test_head, val_test_hand])
    
    # 1 for head; 0 for hand
    y_train = np.hstack([np.ones(len(train_head)),
                         np.zeros(len(train_hand))])
            
    y_val = np.hstack([np.ones(len(val_test_head)),
                       np.zeros(len(val_test_hand))])

    # random forest classifier
    n_estimators = 100
    
    param_distributions = {'n_estimators' : [10, 50, 100, 200, 500, 1000],
                       'criterion' : ['gini'],
              
                       'max_features' : ['sqrt', 'log2', None, 1, 4, 0.25],
                       'max_depth' : [None, 5, 50, 190],
              
                       'min_samples_split' : [2, 10, 100],
                       'min_samples_leaf' : [1, 20, 400],
                       'min_weight_fraction_leaf' : [0.0, 0.01, 0.1],

                       'max_leaf_nodes' : [None, 70, 10, 2],
              
                       'min_impurity_split' : [0.0000001,
                                               0.00001,
                                               0.001],
                       'bootstrap' : [True],
                       'oob_score' : [True],
                       'n_jobs' : [-1],
                       'random_state' : [None],
                       'verbose' : [1],
                       'warm_start' : [False],
                       'class_weight' : [None, 'balanced_subsample']}  

    rf_clf = ske.RandomForestClassifier(n_estimators=100)
#                                       max_features='sqrt',
#                                       max_depth=70,
#                                       max_leaf_nodes=200,
#                                       min_samples_split=6)
#                                        min_samples_leaf=10,
#                                        min_weight_fraction_leaf=0.5,
#                                        min_impurity_split=0.01)
#    
    knn_clf = skn.KNeighborsClassifier(9)
    
    log_reg = sklm.LogisticRegression()
        
    # train
    rf_clf.fit(X, y_train)
    
    # leave-one-out test
    y_predicted = rf_clf.predict(X_LOO)

    # report
    accuracy = skmet.accuracy_score(y_val, y_predicted)
    precision = skmet.precision_score(y_val, y_predicted)
    recall = skmet.recall_score(y_val, y_predicted)
    
    accuracy_collect.append(accuracy)
    precision_collect.append(precision)
    recall_collect.append(recall)
    
    clip_scores = \
        'accuracy  {:.3f},  precision  {:.3f},  recall  {:.3f},  f1  {:.3f}\n'
    
    print('confusion matrix:\n', skmet.confusion_matrix(y_val, y_predicted))
    print(clip_scores.format(accuracy, precision, recall,
                             skmet.f1_score(y_val, y_predicted)))
    #print('ROC AUC:         ', skmet.roc_auc_score(y_val, y_predicted), '\n')     
    

print('tags:', tag3)
print('n_estimators:', n_estimators)
print(ftype)

print('Accuracy: ',
      'min {:.2f}, median {:.2f}, mean {:.2f}, max {:.2f}'.format(\
           np.min(accuracy_collect),
           np.median(accuracy_collect),
           np.mean(accuracy_collect),
           np.max(accuracy_collect)))      
    
print('Precision:',
      'min {:.2f}, median {:.2f}, mean {:.2f}, max {:.2f}'.format(\
           np.min(precision_collect),
           np.median(precision_collect),
           np.mean(precision_collect),
           np.max(precision_collect)))    

print('Recall   :',
      'min {:.2f}, median {:.2f}, mean {:.2f}, max {:.2f}'.format(\
           np.min(recall_collect),
           np.median(recall_collect),
           np.mean(recall_collect),
           np.max(recall_collect)))    
    
    
    
'''
n_estimators: 100
no summation over 45 frames
Accuracy:  min 0.51, median 0.76, mean 0.73, max 0.83
Precision: min 0.53, median 0.77, mean 0.77, max 0.95
Recall   : min 0.15, median 0.78, mean 0.71, max 0.94


n_estimators: 100
summation over 45 frames
Accuracy:  min 0.51, median 0.71, mean 0.70, max 0.87
Precision: min 0.50, median 0.74, mean 0.71, max 0.88
Recall   : min 0.23, median 0.73, mean 0.71, max 1.00


tag: exemplars_and_labels_and_feature_vectors_8___
n_estimators: 100
histogram of flow - no summation over 45 frames
Accuracy:  min 0.68, median 0.73, mean 0.75, max 0.83
Precision: min 0.62, median 0.79, mean 0.77, max 0.97
Recall   : min 0.57, median 0.70, mean 0.69, max 0.80

tag: exemplars_and_labels_and_feature_vectors_8___
n_estimators: 100
histogram of flow - summation over 45 frames
Accuracy:  min 0.45, median 0.64, mean 0.64, max 0.77
Precision: min 0.46, median 0.64, mean 0.65, max 0.96
Recall   : min 0.29, median 0.61, mean 0.61, max 0.79

tag: exemplars_and_labels_and_feature_vectors_32___
n_estimators: 100
histogram of flow - no summation over 45 frames
Accuracy:  min 0.58, median 0.72, mean 0.72, max 0.87
Precision: min 0.55, median 0.73, mean 0.74, max 0.90
Recall   : min 0.58, median 0.64, mean 0.68, max 0.83

tag: exemplars_and_labels_and_feature_vectors_32___
n_estimators: 100
histogram of flow - summation over 45 frames
Accuracy:  min 0.55, median 0.66, mean 0.66, max 0.80
Precision: min 0.45, median 0.65, mean 0.66, max 0.93
Recall   : min 0.45, median 0.65, mean 0.67, max 0.91

tag: exemplars_labels_and_flow_mag_sum_feature_vectors_28x28___
n_estimators: 100
flow mag sum over 45 frames
Accuracy:  min 0.68, median 0.79, mean 0.78, max 0.93
Precision: min 0.64, median 0.78, mean 0.79, max 0.95
Recall   : min 0.45, median 0.79, mean 0.77, max 1.00

tags: exemplars_and_labels_and_feature_vectors_8___ exemplars_labels_and_flow_mag_sum_feature_vectors_28x28___
n_estimators: 100
histogram of flow - no summation over 45 frames and 
flow mag sum over 45 frames
Accuracy:  min 0.67, median 0.81, mean 0.80, max 0.96
Precision: min 0.68, median 0.84, mean 0.81, max 0.94
Recall   : min 0.50, median 0.76, mean 0.78, max 1.00

tags: exemplars_and_labels_and_feature_vectors_8___ exemplars_labels_and_flow_mag_sum_feature_vectors_28x28___
n_estimators: 100
histogram of flow - summation over 45 frames and 
flow mag sum over 45 frames
Accuracy:  min 0.69, median 0.80, mean 0.79, max 0.89
Precision: min 0.66, median 0.80, mean 0.80, max 1.00
Recall   : min 0.50, median 0.78, mean 0.77, max 1.00


tags: exemplars_and_labels_and_feature_vectors_32___ exemplars_labels_and_flow_mag_sum_feature_vectors_28x28___
n_estimators: 100
histogram of flow - no summation over 45 frames and 
flow mag sum over 45 frames
Accuracy:  min 0.68, median 0.78, mean 0.78, max 0.96
Precision: min 0.65, median 0.80, mean 0.79, max 1.00
Recall   : min 0.47, median 0.77, mean 0.76, max 0.92

tags: exemplars_and_labels_and_feature_vectors_32___ exemplars_labels_and_flow_mag_sum_feature_vectors_28x28___
n_estimators: 100
histogram of flow - summation over 45 frames and 
flow mag sum over 45 frames
Accuracy:  min 0.70, median 0.83, mean 0.81, max 0.89
Precision: min 0.68, median 0.82, mean 0.82, max 1.00
Recall   : min 0.57, median 0.82, mean 0.80, max 1.00

tags: exemplars_labels_and_stuff_as_feature_vectors_100x100___
n_estimators: 100
overlaid skin detection over 45 frames
Accuracy:  min 0.80, median 0.86, mean 0.87, max 0.95
Precision: min 0.76, median 0.93, mean 0.90, max 1.00
Recall   : min 0.58, median 0.86, mean 0.82, max 1.00

tags: exemplars_labels_and_stuff_as_feature_vectors_100x100___
n_estimators: 100
histogram of flow - summation over 45 frames
and overlaid skin detection over 45 frames
Accuracy:  min 0.79, median 0.86, mean 0.86, max 0.96
Precision: min 0.75, median 0.91, mean 0.90, max 1.00
Recall   : min 0.58, median 0.81, mean 0.82, max 1.00
'''    




   
        
    




    