# -*- coding: utf-8 -*-
"""
Created on Thu Feb 22 11:18:28 2018

@author: Callie Darsey
"""

import cv2
import numpy as np

def print_one_channel_image(image):
    
    for row in image:
        s = ''
        for element in row:
            s = s + '{:3d}'.format(element) + ', '
        print(s)
    print('')
    
def print_elements(one_dimension_array):
    s = ''
    for element in one_dimension_array:
        s = s + '{:3d}, '.format(element)
    print(s)
    print('')

I = cv2.imread('50264881_00101_0107_Medium.jpg')

row_start = 130
height = 6

col_start = 107
width = 6

image = I[row_start:row_start + height, col_start:col_start + width, :]

image_gray = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)

print('\nimage_gray.shape', image_gray.shape, '\n')
print_one_channel_image(image_gray)

# print some newlines
print('\n\n')



# dimensions (36,)
image_gray_reshaped_1 = image_gray.reshape(-1)

print('image_gray_reshaped_1.shape', image_gray_reshaped_1.shape, '\n')

print_elements(image_gray_reshaped_1)

print(image_gray_reshaped_1)

# dimensions (1, 36)
image_gray_reshaped_2 = image_gray.reshape((1, -1))

print('\nimage_gray_reshaped_2.shape', image_gray_reshaped_2.shape, '\n')

print_one_channel_image(image_gray_reshaped_2)

print(image_gray_reshaped_2)

cv2.imshow('BGR (Press any key to escape)', image)
cv2.imshow('Gray (Press any key to escape)', image_gray)


cv2.waitKey(0)

cv2.destroyAllWindows()

