# -*- coding: utf-8 -*-
"""
Created on Fri May 18 21:48:35 2018

@author: Callie Darsey

gather_the_classified_patches_01
"""

import pickle
import numpy as np
import sklearn.ensemble as ske
import sklearn.metrics as skmet
import sklearn.neighbors as skn
import sklearn.linear_model as sklm
import sklearn.model_selection as sklms
import matplotlib.pyplot as plt
import cv2
import sklearn.tree as sklt

def merge_my_dicts(d_list):
    '''
    '''
    print('merging')
    my_merged_dict = {}
    
    for key in d_list[0].keys():
        #print(key)
        
        for d in d_list[1:]:
            assert key in d.keys()
            assert np.count_nonzero([d_list[0][key][0] != d[key][0]]) == 0
            assert d_list[0][key][1] == d[key][1]
            
        val = [d_list[0][key][0], d_list[0][key][1]]
        
        features = []
        
        for d in d_list:
            
            features = features + [d[key][2]]
            
        val = val + [np.hstack(features)]

        my_merged_dict[key] = val
        
    return my_merged_dict


        
e1 = cv2.getTickCount()

'''
"patches_all_segments_labels___feature_correct_hist_of_flow_Bins_32___",
"patches_all_segments_labels___feature_correct_hist_of_flow_div_counts_Bins_32___",
"patches_all_segments_labels___feature_correct_hists_of_flow_Bins_32___",
"patches_all_segments_labels___feature_correct_hists_of_flow_div_counts_Bins_32___",
"patches_all_segments_labels___feature_correct_sum_hists_of_flow_div_counts_Bins_32___",
"patches_all_segments_labels___feature_skin_bool_Bins_32___",
"patches_all_segments_labels___feature_skin_count_Bins_32___",
"patches_all_segments_labels___feature_watershed_skin_bool_Bins_32___",
'patches_all_segments_labels___feature_flow_mag_sum_all_Bins_32___' 
'''

upper = './wheeler/dataset/'
tags = ['patches_all_segments_labels___feature_skin_bool_Bins_32___',
        'patches_all_segments_labels___feature_watershed_skin_bool_Bins_32___',
        'patches_all_segments_labels___feature_flow_mag_sum_all_Bins_32___',
        'patches_all_segments_labels___feature_skin_count_Bins_32___',
'patches_all_segments_labels___feature_correct_hist_of_flow_div_counts_Bins_32___']

ftypes = ['skin bool',
          'watershed skin bool',
          'flow mag sum all',
          'skin count',
          'hist of flow divided by counts']

clip_infos = [[]] * 15

clip_infos_classified = [{}] * 15

names = [\
'part1/MVI_0069_trans/',
'STI_Polk_Apr13_C/MVI_0039_trans/',
'STI_Polk_Apr27_A/MVI_0073_trans/',
'STI_Polk_Apr27_D/MVI_0063_trans/',
'STI_Polk_May04_A/MVI_0087_trans/',
'STI_Polk_May11_C/MVI_0108_trans/',
'STI_WA_Apr11_extra_B/MVI_0036_trans/',
'STI_WA_Jun12_B/MVI_0018_trans/',
'STI_WA_Jun14_Lb/MVI_0070_trans/',
'STI_WA_Jun20_CT/MVI_0029_trans/',
'STI_WA_Jun22_De/MVI_0118_trans/',
'STI_WA_Jun23_Da/MVI_0112_trans/',
'STI_WA_May02_B/MVI_0053_trans/',
'STI_WA_May02_C/MVI_0074_trans/',
'STI_WA_May09_A/MVI_0109_trans/']
         

for tag in tags:
    
    clip_info = [\
    upper + 'part1/MVI_0069_trans/' + tag + 'MVI_0069_trans__0_100.data',
    upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag + 'MVI_0039_trans__460_563.data',
    upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag + 'MVI_0073_trans__0_100.data',
    upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag + 'MVI_0074_trans__240_342.data',
    upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag + 'MVI_0087_trans__579_680.data',
    upper + 'STI_Polk_May11_C/MVI_0108_trans/' + tag + 'MVI_0108_trans__0_42.data',
    upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag + 'MVI_0036_trans__870_912.data',
    upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag + 'MVI_0018_trans__910_954.data',
    upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag + 'MVI_0070_trans__670_712.data',
    upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag + 'MVI_0029_trans__515_557.data',
    upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag + 'MVI_0118_trans__100_142.data',
    upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag + 'MVI_0112_trans__15_57.data',
    upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag + 'MVI_0053_trans__0_100.data',
    upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag + 'MVI_0074_trans__60_102.data',
    upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag + 'MVI_0109_trans__0_42.data']
    
    for i, data in enumerate(clip_info):
        
        clip_infos[i] = clip_infos[i] + [data]


segment = 45

# holds head and hand feature vectors per clip

feature_vectors_per_clip = []
labels_per_clip = []

for clip in clip_infos:
    
    patches_infos = []
    
    for data in clip:
        
        with open(data, 'rb') as f:
            
            patches_info = pickle.load(f)
                        
        patches_infos.append(patches_info)
    
    patches_info_merged = merge_my_dicts(patches_infos)
    

    features_collected = []
    labels_collected = []
        
    for info in patches_info_merged.values():
        
        patches, labels, feature = info[0], info[1], info[2]
        
        col_start, row_start, col_end, row_end = tuple(patches[0])
        patch_size = (col_end - col_start + 1) * (row_end - row_start + 1)
        
        patches_per_segment = patches.shape[0]
        
        tags_ar = np.array(labels)
        
        binary_labels = np.zeros(len(labels))
        binary_labels[np.where(tags_ar == 'predominately hand')[0]] = 1
        
        features_collected.append(info[2])
        labels_collected.append(binary_labels)
        

    # stack for clip
    features_collected = np.vstack(features_collected)
    labels_collected = np.hstack(labels_collected)

    
    # collect per clip
    feature_vectors_per_clip.append(features_collected)
    labels_per_clip.append(labels_collected)
    

indices = np.arange(len(clip_infos))

data_files_vote = \
['fold_classifiers.y2018m05d17-h16m58s24.data',
 'fold_classifiers.y2018m05d18-h12m46s52.data',
 'fold_classifiers.y2018m05d18-h12m54s47.data',
 'fold_classifiers.y2018m05d18-h12m55s19.data',
 'fold_classifiers.y2018m05d18-h12m56s44.data',
 'fold_classifiers.y2018m05d18-h12m57s15.data',
 'fold_classifiers.y2018m05d18-h12m57s50.data',
 'fold_classifiers.y2018m05d18-h12m58s18.data',
 'fold_classifiers.y2018m05d18-h12m58s46.data',
 'fold_classifiers.y2018m05d18-h12m59s15.data',
 'fold_classifiers.y2018m05d18-h13m17s24.data',
 'fold_classifiers.y2018m05d18-h13m43s57.data',
 'fold_classifiers.y2018m05d18-h13m44s21.data',
 'fold_classifiers.y2018m05d18-h13m44s44.data',
 'fold_classifiers.y2018m05d18-h13m45s08.data',
 'fold_classifiers.y2018m05d18-h13m45s32.data',
 'fold_classifiers.y2018m05d18-h13m45s55.data',
 'fold_classifiers.y2018m05d18-h13m46s19.data',
 'fold_classifiers.y2018m05d18-h13m46s42.data',
 'fold_classifiers.y2018m05d18-h13m47s06.data',
 'fold_classifiers.y2018m05d18-h13m47s29.data']

#saves = []
#
#prev_tags = ''
#
#for i, data_file in enumerate(data_files_vote):
#    
#    with open('./wheeler/dataset/three_way_classify/' + data_file, 'rb') as f:
#        
#        tags, save = pickle.load(f)
#        
#    if i != 0:
#        
#        assert prev_tags == tags
#        
#    prev_tags = tags
#    
#    saves.append(save)


# places to save the labels for the three paths for predicting labels

NON_PRUNED = 0


label_predictions_per_clip = [[]] * 5

specificity_collect = [[]] * 5
fpr_collect = [[]] * 5
tpr_collect = [[]] * 5
precision_collect = [[]] * 5
accuracy_collect = [[]] * 5

roc_auc_keep_collect = [[]] * 5
roc_auc_all_collect = [[]] * 5

''' non balanced dataset '''
#with open('./wheeler/dataset/three_way_classify/'+ \
#    'roc_exemple.fold_classifiers.y2018m05d20-h01m24s37.data', 'rb') as f:    
 
'''balanced starting dataset '''
#with open('./wheeler/dataset/three_way_classify/'+ \
#    'roc_exemple.fold_classifiers.y2018m05d20-h00m24s33.data', 'rb') as f:

#with open('./wheeler/dataset/three_way_classify/'+ \
#    'roc_exemple.fold_classifiers.y2018m05d20-h00m24s33.data', 'rb') as f:   
#    feature_tags, saves = pickle.load(f)

with open('./wheeler/dataset/three_way_classify/'+ \
    'roc_exemple.fold_classifiers.y2018m05d20-h00m24s33.data', 'rb') as f:   
    feature_tags, saves = pickle.load(f)

for i in indices:
   
    ei = cv2.getTickCount()
    
    print(names[i])
    
    X_LOO = feature_vectors_per_clip[i]
    y_LOO = labels_per_clip[i] 
    
        
    label_predictions = np.array(['                   '] * y_LOO.shape[0])


    y_mark_keep_skin = np.zeros_like(y_LOO)
    y_mark_keep_watershed_skin = np.zeros_like(y_LOO)
    y_mark_keep_flow_mag_sum_all = np.zeros_like(y_LOO)
    y_mark_keep_skin_count = np.zeros_like(y_LOO)
    
    y_mark_keep_skin[np.where(X_LOO[:, 0] > 0)[0]] = 1
    
    y_mark_keep_watershed_skin[np.where(X_LOO[:, 1] > 0)[0]] = 1

    y_mark_keep_flow_mag_sum_all[np.where(np.all([X_LOO[:, 2] > 100],
                                                 axis=0))[0]] = 1
            
    y_mark_keep_skin_count[np.where(np.all([X_LOO[:, 3] / patch_size > 0.2,
                                            X_LOO[:, 3] / patch_size <= 1.0 ],
                                            axis=0))[0]] = 1
    
    y_mark_keep = np.all([y_mark_keep_skin_count,
                          y_mark_keep_flow_mag_sum_all], axis=0)
    
    keep_indices = np.where(y_mark_keep)[0]
    
    label_predictions[np.logical_not(y_mark_keep)] = 'pruned'
            
#    # now classify the feature vectors
#    predictions_collected = []
#    for s in [saves[i][0]]:
#        
#        if isinstance(s, sklms.RandomizedSearchCV):
#            
#            predictions_collected.append(\
#                s.best_estimator_.predict(X_LOO[:, 3:]))
#            
#        elif isinstance(s, ske.RandomForestClassifier):
#            
#            predictions_collected.append(s.predict(X_LOO[:, 3:]))
#            
#    predictions = np.vstack(predictions_collected)
#    
#    rows, cols = predictions.shape
#    
#    hand_votes = np.sum(predictions, axis=0)
#    non_hand_votes = rows - hand_votes
#    
#    predictions_vote = np.argmax(np.vstack([non_hand_votes, hand_votes]),
#                                 axis=0)
#    
#    y_predicted = np.all([y_mark_keep, predictions_vote],
#                         axis=0).astype(np.uint8)



    model = saves[i][4]



    # The random forest model by itself
    y_predict_proba = model.predict_proba(X_LOO[:, 4:])
    
    # KEEP  ROC curve
    fpr_keep, tpr_keep, thresholds_fpr_vs_tpr_keep = \
        skmet.roc_curve(y_LOO[keep_indices], y_predict_proba[keep_indices, 1])
        
    roc_auc_macro_keep = skmet.roc_auc_score(y_LOO[keep_indices],
                                             y_predict_proba[keep_indices, 1])
    
    roc_auc_weighted_keep = skmet.roc_auc_score(y_LOO[keep_indices],
                                y_predict_proba[keep_indices, 1], 'weighted')
    
    # ALL ROC curve
    fpr_all, tpr_all, thresholds_fpr_vs_tpr_all = \
        skmet.roc_curve(y_LOO, y_predict_proba[:, 1])
        
    roc_auc_macro_all = skmet.roc_auc_score(y_LOO, y_predict_proba[:, 1])    
    
    roc_auc_weighted_all = skmet.roc_auc_score(y_LOO, y_predict_proba[:, 1],
                                               'weighted')    
    
    # KEEP precision recall curve
    precision_keep, recall_keep, thresholds_prec_vs_recall_keep = \
        skmet.precision_recall_curve(y_LOO[keep_indices],
                                     y_predict_proba[keep_indices, 1])
        
    # ALL precision recall curve
    precision_all, recall_all, thresholds_prec_vs_recall_all = \
        skmet.precision_recall_curve(y_LOO, y_predict_proba[:, 1])        
    
    
    # make the plots
    plt.figure(1)
    plt.plot([0, 1], [0, 1], 'k--')
    plt.plot(fpr_keep, tpr_keep,
        label='RF' + ' ({:.2f} (macro), {:.2f} (weighted))'.format(\
        roc_auc_macro_keep, roc_auc_weighted_keep))
    plt.xlabel('False positive rate')
    plt.ylabel('True positive rate')
    plt.title('ROC curve (KEEP)')
    plt.legend(loc='best')
    plt.show()
    
    plt.figure(1)
    plt.plot([0, 1], [0, 1], 'k--')
    plt.plot(fpr_all, tpr_all,
        label='RF' + ' ({:.2f} (macro), {:.2f} (weighted))'.format(\
        roc_auc_macro_all, roc_auc_weighted_all))
    plt.xlabel('False positive rate')
    plt.ylabel('True positive rate')
    plt.title('ROC curve (ALL)')
    plt.legend(loc='best')
    plt.show()
    
    plt.figure(1)
    plt.plot(recall_keep, precision_keep, label='RF')
    plt.xlabel('True positive rate (aka Sensitivity) (aka Recall (on positive)')
    plt.ylabel('Precision = FP / (FP + TP)')
    plt.title('Precision versus Recall (KEEP)')
    plt.legend(loc='best')
    plt.show()

    plt.figure(1)
    plt.plot(recall_all, precision_all, label='RF')
    plt.xlabel('True positive rate (aka Sensitivity) (aka Recall (on positive)')
    plt.ylabel('Precision = FP / (FP + TP)')
    plt.title('Precision versus Recall (ALL)')
    plt.legend(loc='best')
    plt.show()
    
    # choose operating points according to euclian distance
    euclidian_dist_ROC_keep = np.sqrt(fpr_keep ** 2 + (1 - tpr_keep) ** 2)
    
    euclidian_dist_ROC_all = np.sqrt(fpr_all ** 2 + (1 - tpr_all) ** 2)
    
    ind_keep = np.argmin(euclidian_dist_ROC_keep)
    
    ind_all = np.argmin(euclidian_dist_ROC_all)
    
    thresh_keep = thresholds_fpr_vs_tpr_keep[ind_keep]
    
    thresh_all = thresholds_fpr_vs_tpr_all[ind_all]
    
    # y predictions unmasked by pruning
    
    y_pred_thresh_all = np.where(y_predict_proba > thresh_all)[0]
    
    y_pred_thresh_keep = np.where(y_predict_proba > thresh_keep)[0]
    
    # y predictions masked by pruning
    
    y_pred_thresh_all_masked_by_keep = np.all([y_pred_thresh_all,
                                               y_mark_keep], axis=0)
    
    y_pred_thresh_keep_masked_by_keep = np.all([y_pred_thresh_keep,
                                                y_mark_keep], axis=0)
    
    # report on non-pruned classification
    NON_PRUNED = 0
    
    
    label_predictions_per_clip = [[]] * 5
    
    specificity_collect = [[]] * 5
    fpr_collect = [[]] * 5
    tpr_collect = [[]] * 5
    precision_collect = [[]] * 5
    accuracy_collect = [[]] * 5
    
    roc_auc_keep_collect = [[]] * 5
    roc_auc_all_collect = [[]] * 5
    
    

        
    
    
#    prob_threshold = 0.4
#    
#    predictions_vote = y_pred_rf[:, 1] > prob_threshold
#    
#    print(np.count_nonzero(y_LOO))
#    print(np.count_nonzero(y_pred_rf[:, 1] > prob_threshold))
#
#    y_predicted = np.all([y_mark_keep, predictions_vote],
#                         axis=0).astype(np.uint8)
#    
#    label_predictions[np.all([label_predictions != 'pruned',
#                        y_predicted == False], axis=0)] = 'classifed-non-hand'
#    
#    label_predictions[y_predicted == True] = 'classifed-hand'
#    
#    # save for clip
#    label_predictions_per_clip.append(label_predictions)
#    
#    # report
#    confusion_matrix = skmet.confusion_matrix(y_LOO, y_predicted)
#    accuracy = skmet.accuracy_score(y_LOO, y_predicted)
#    precision = skmet.precision_score(y_LOO, y_predicted, labels=[0, 1],
#                                      average=None)
#    specificity = confusion_matrix[0, 0] / (confusion_matrix[0, 0] + confusion_matrix[0, 0])
#    false_positive_rate = 1 - specificity
#    sensitivity = skmet.recall_score(y_LOO, y_predicted, labels=[0, 1],
#                                average=None)
#    
#    f1 = skmet.f1_score(y_LOO, y_predicted, labels=[0, 1], average=None)
#
#    
#    accuracy_collect.apppend(accuracy)
#    precision_collect.apppend(precision)
#    specificity_collect.apppend(specificity)
#    false_positive_rate.apppend(false_positive_rate)
#    sensitivity_collect.apppend(sensitivity)
#    f1_collect.apppend(f1)
#    roc_auc_collect.apppend(roc_auc_rf)    
#    
#
#    accuracy_row     = 'Accuracy       {:12.3f}'
#    header_row       = '               non-hand          hand'    
#    precision_row    = 'Precision      {:12.3f}  {:12.3f}'
#    specificity_row  = 'Specificity    {:12.3f}  {:12.3f}'
#    recall_row       = 'Recall         {:12.3f}  {:12.3f}'
#    f1_row           = 'F1 score       {:12.3f}  {:12.3f}'
#    
#    
#    print(accuracy_row.format(accuracy))
#    print('confusion matrix:\n', confusion_matrix)
#    print(header_row)
#    print(precision_row.format(precision[0], precision[1]))
#    print(recall_row.format(recall[0], recall[1]))
#    print(f1_row.format(f1[0], f1[1]))
#    
#    
#    ee = cv2.getTickCount()
#    print("Per clip execution {:.2f} seconds".format(\
#        (ee - ei) / cv2.getTickFrequency()))
#
#print('\ntag(s):'); print(tag)
#
#
#accuracy_collect = np.vstack(accuracy_collect)
#precision_collect = np.vstack(precision_collect)
#recall_collect = np.vstack(recall_collect)
#f1_collect = np.vstack(f1_collect)
#                
#roc_auc_collect = np.vstack(roc_auc_collect)
#
#accuracy_row  = 'Accuracy'
#minimum_row   = '          Minimum    {:12.3f}'
#median_row    = '          Median     {:12.3f}'
#mean_row      = '          Mean       {:12.3f}'
#maximum_row   = '          Maximum    {:12.3f}'
#
#print(accuracy_row)
#print(minimum_row.format(np.min(accuracy_collect)))
#print(median_row.format(np.median(accuracy_collect)))
#print(mean_row.format(np.mean(accuracy_collect)))
#print(maximum_row.format(np.max(accuracy_collect)))
#
#precision_row = 'Precision              non-hand          hand'
#recall_row    = 'Recall                 non-hand          hand'
#minimum_row   = '          Minimum  {:12.3f}  {:12.3f}'
#median_row    = '          Median   {:12.3f}  {:12.3f}'
#mean_row      = '          Mean     {:12.3f}  {:12.3f}'
#maximum_row   = '          Maximum  {:12.3f}  {:12.3f}'
#
#print(precision_row)
#print(minimum_row.format(np.min(precision_collect[:, 0]), 
#                         np.min(precision_collect[:, 1])))
#print(median_row.format(np.median(precision_collect[:, 0]),
#                        np.median(precision_collect[:, 1])))
#print(mean_row.format(np.mean(precision_collect[:, 0]),
#                      np.mean(precision_collect[:, 1])))
#print(maximum_row.format(np.max(precision_collect[:, 0]),
#                         np.max(precision_collect[:, 1])))
#
#print(recall_row)
#print(minimum_row.format(np.min(recall_collect[:, 0]), 
#                         np.min(recall_collect[:, 1])))
#print(median_row.format(np.median(recall_collect[:, 0]),
#                        np.median(recall_collect[:, 1])))
#print(mean_row.format(np.mean(recall_collect[:, 0]),
#                      np.mean(recall_collect[:, 1])))
#print(maximum_row.format(np.max(recall_collect[:, 0]),
#                         np.max(recall_collect[:, 1])))
#
#                
#roc_auc_row   = 'ROC AUC               RF'    
#minimum_row   = '          Minimum  {:7.3f}'
#median_row    = '          Median   {:7.3f}'
#mean_row      = '          Mean     {:7.3f}'
#maximum_row   = '          Maximum  {:7.3f}'
#
#print(roc_auc_row)
#print(minimum_row.format(np.min(roc_auc_collect)))
#print(median_row.format(np.median(roc_auc_collect)))
#print(mean_row.format(np.mean(roc_auc_collect)))
#print(maximum_row.format(np.max(roc_auc_collect)))    
#
#
#
## pickle the dictionary with the segment keys, patches and classification labels
#tag = 'patches_and_classified_labels___'
#classified_clip_info = [\
#upper + 'part1/MVI_0069_trans/' + tag + 'MVI_0069_trans__0_100.data',
#upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag + 'MVI_0039_trans__460_563.data',
#upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag + 'MVI_0073_trans__0_100.data',
#upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag + 'MVI_0074_trans__240_342.data',
#upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag + 'MVI_0087_trans__579_680.data',
#upper + 'STI_Polk_May11_C/MVI_0108_trans/' + tag + 'MVI_0108_trans__0_42.data',
#upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag + 'MVI_0036_trans__870_912.data',
#upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag + 'MVI_0018_trans__910_954.data',
#upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag + 'MVI_0070_trans__670_712.data',
#upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag + 'MVI_0029_trans__515_557.data',
#upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag + 'MVI_0118_trans__100_142.data',
#upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag + 'MVI_0112_trans__15_57.data',
#upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag + 'MVI_0053_trans__0_100.data',
#upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag + 'MVI_0074_trans__60_102.data',
#upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag + 'MVI_0109_trans__0_42.data']
#
#for i, classified_clip in enumerate(classified_clip_info):
#    
#    label_predictions = label_predictions_per_clip[i]
#    
#    segments = label_predictions.shape[0] / patches_per_segment
#    
#    keys = [(first, last) for first, last in \
#            zip(np.arange(0, 180 * segments, 180),
#                np.arange(176, 180 * segments + 176, 180))]
#    
#    dictionary = {}
#    
#    for k, key in enumerate(keys):
#        
#        dictionary[key] = [patches,
#            list(label_predictions[k * patches_per_segment : \
#                              k * patches_per_segment + patches_per_segment])]
#    
#    with open(classified_clip, 'wb') as f:
#        
#        pickle.dump(dictionary, f)
#    
#    
#    
#



e2 = cv2.getTickCount()
print("Total execution {:.2f} seconds".format(\
    (e2 - e1) / cv2.getTickFrequency()))