# -*- coding: utf-8 -*-
"""
Created on Fri May 18 16:22:06 2018

@author: Callie Darsey

gathered_display_01
"""



import numpy as np
import cv2
from matplotlib import pyplot as plt
import fns_investigating_optical_flow_01 as fns
import os
import overlay_01 as overlay
import Adjustable_BB_05 as Adjustable_BB
import datetime
import pickle
import sys


# video path
path_common = './video_copies_clips_track/copies_and_clips_wave_04/'


#path_specific = "STI Polk Apr27 A/MVI_0073_trans/"
#video_name = "MVI_0073_trans__0_100"
              
#path_specific = "STI Polk May11 C/MVI_0108_trans/"
#video_name = "MVI_0108_trans__0_42"

#path_specific = "STI WA Jun12 B/MVI_0018_trans/"
#video_name = "MVI_0018_trans__910_954"

#path_specific = "STI WA May09 A/MVI_0109_trans/"
#video_name = "MVI_0109_trans__0_42"

#path_specific = "STI WA May02 C/MVI_0074_trans/"
#video_name = "MVI_0074_trans__60_102"

#path_specific = "STI WA Apr11 extra B/MVI_0036_trans/"
#video_name = "MVI_0036_trans__870_912"

#path_specific = "STI WA Jun14 Lb/MVI_0070_trans/"
#video_name = "MVI_0070_trans__670_712"

#path_specific = "STI WA Jun22 De/MVI_0118_trans/"
#video_name = "MVI_0118_trans__100_142"

#path_specific = "STI WA Jun23 Da/MVI_0112_trans/"
#video_name = "MVI_0112_trans__15_57"

#path_specific = "STI WA Jun20 CT/MVI_0029_trans/"
#video_name = "MVI_0029_trans__515_557"



#path_specific = "STI Polk Apr27 D/MVI_0063_trans/"
#video_name = "MVI_0074_trans__240_342"

#path_specific = "STI WA May02 B/MVI_0053_trans/"
#video_name = "MVI_0053_trans__0_100"

path_specific = "part1/MVI_0069_trans/"
video_name = "MVI_0069_trans__0_100"

#path_specific = "STI Polk Apr13 C/MVI_0039_trans/"
#video_name = "MVI_0039_trans__460_563"

#path_specific = "STI Polk May04 A/MVI_0087_trans/"
#video_name = "MVI_0087_trans__579_680"


exemplar_path = './video_copies_clips_track/copies_and_clips_wave_04/' + \
            path_specific + 'exemplars_and_labels___' + video_name + '.data'
                
patches_path = './wheeler/dataset/' + path_specific.replace(' ', '_') + \
            'patches_all_segments_labels___' + video_name + '.data'

patches_classified_path = './wheeler/dataset/' + \
                          path_specific.replace(' ', '_') + \
                'patches_and_classified_labels___' + video_name + '.data'
                
                
                
                
face_detection_path = './wheeler/dataset/' + path_specific.replace(' ', '_') + \
                video_name + '.wenjing_face_detections.mp4'
back_detection_path = './wheeler/dataset/' + path_specific.replace(' ', '_') + \
                video_name + '.wenjing_back_detections.mp4'
boy_back_detection_path = './wheeler/dataset/' + path_specific.replace(' ', '_') + \
                video_name + '.wenjing_boy_back_detections.mp4'
cleaned_skin_path = './wheeler/dataset/' + path_specific.replace(' ', '_') + \
                video_name + '.cleaned_skin.mp4'

cap_face = cv2.VideoCapture(face_detection_path)
cap_back = cv2.VideoCapture(back_detection_path)
cap_boy_back = cv2.VideoCapture(boy_back_detection_path)
cap_cleaned_skin = cv2.VideoCapture(cleaned_skin_path)

success_flag_face, face_mask = cap_face.read()
assert success_flag_face, "On first attempt after construction, could \
    not read frame from {}".format(face_detection_path) 

success_flag_back, back_mask = cap_back.read()
assert success_flag_back, "On first attempt after construction, could \
    not read frame from {}".format(back_detection_path) 

success_flag_boy_back, boy_back_mask =  cap_boy_back.read()
assert success_flag_boy_back, "On first attempt after construction, could \
    not read frame from {}".format(boy_back_detection_path) 

success_flag_cleaned_skin, cleaned_skin = cap_cleaned_skin.read()
assert success_flag_cleaned_skin, "On first attempt after construction, could \
    not read frame from {}".format(cleaned_skin_path)     

'''
bool for whether the input video already has reduced frames
'''
reduced_frames = False
             

# Setting to play with

'''Resolution rescaling factor'''
scaleFactor = 0.67
#scaleFactor = 1.0

'''
normalization of optical flow by resolution scaling factor and 
number of frames advanced
'''
normalize_scale = False
normalize_frame_advance = False

''' wait to calculate optical flow and display '''
frame_wait = 0



'''
Whether to display the video
'''
displayVideo = True

'''
insert frame number into frame
'''
insert_frame_number = True


''' draw existing exemplars into frame '''
place_existing_exemplars = True


''' draw patches into frame '''
place_patches = False


''' draw classified patches into frame '''
place_classified_patches = True


''' place wenjing detections '''
place_wenjing = False


'''
has exemplar point and label info
'''
   
#pickle_path_old = path_common + path_specific + exemplar_old

with open(exemplar_path, 'rb') as f:
    exemplar_points_and_labels = pickle.load(f)
    
with open(patches_path, 'rb') as f:
    patch_points_and_labels = pickle.load(f)

with open(patches_classified_path, 'rb') as f:
    patch_points_and_classified_labels = pickle.load(f)
      
# process the mp4 video
video_path = path_common + path_specific + video_name + '.mp4'
cap = cv2.VideoCapture(video_path)

num_frames = cap.get(cv2.CAP_PROP_FRAME_COUNT)
fps = cap.get(cv2.CAP_PROP_FPS )

'''Frames to advance between frames passed to optical flow'''
framesToAdvance = np.int32(np.ceil(fps / 15))

print('number of frames:', num_frames, ', frames per second:', fps,
      'framesToAdvance:', framesToAdvance)



# initialize frame1
success_flag, frame1_full = cap.read()

assert success_flag, "On first attempt after construction, could \
                      not read frame from {}".format(video_path)  
                            
frame1 = cv2.resize(frame1_full, (0,0), fx=scaleFactor, fy=scaleFactor) 

'''
save frames
'''
segment = True
seconds = 3
if segment == True:
    num_frames = np.int32(np.ceil(seconds * fps))
    number_saved = np.int32(np.ceil(seconds * fps / framesToAdvance))
    print('number saved:', number_saved)
    
else:
    num_frames = 300
    number_saved = 75


saved_frames = []
frame_number = []
ind = -1

# prep window
title = 'display window'
move_window = [60, -30]
cv2.namedWindow(title, cv2.WINDOW_AUTOSIZE)
#cv2.namedWindow(title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
cv2.moveWindow(title, move_window[0], move_window[1])


# loop through the frames and display

# announce
print("Press Esc on the image to exit")

e1 = cv2.getTickCount()

count = 0


# last frame got was the last
last_frame = False

while(cap.isOpened()):
                
    # skip frames
    for i in range(framesToAdvance):
        success_flag, frame2_full = cap.read()
        
        count += 1
        
        if count % 4 == 0:
            
            success_flag_cleaned_skin, cleaned_skin = cap_cleaned_skin.read()
            if not success_flag_cleaned_skin:
                print('count is {}'.format(count))
                break
            
        if count % 36 == 0:
            
            success_flag_face, face_mask = cap_face.read()
            assert success_flag_face, 'count is {}'.format(count)
            
            success_flag_back, back_mask = cap_back.read()
            assert success_flag_back, 'count is {}'.format(count)
            
            success_flag_boy_back, boy_back_mask =  cap_boy_back.read()
            assert success_flag_boy_back, 'count is {}'.format(count)

        if (not success_flag):
            print("no more frames in this capture")
            last_frame = True
            
                 
    if success_flag or last_frame == True:
    # process upon true read frame success_flag
    
        if count > 0:
            
            if last_frame is False:

                        
                #initialize frame2
                frame2 = cv2.resize(frame2_full, (0,0), fx=scaleFactor, fy=scaleFactor)             

                if displayVideo == True:
                        
                    frame_to_display = frame1
        
                    if insert_frame_number == True:
                                        
                        # draw the text
                        cv2.putText(frame_to_display, str(count - framesToAdvance),
                                    (frame_to_display.shape[1] - 100, 25),
                                     cv2.FONT_HERSHEY_SIMPLEX, 1, (0, 255, 0), 2)
                        
                    if place_existing_exemplars == True:

                        if len(exemplar_points_and_labels.keys()) > 0:
                            
                            frame_num = (count - framesToAdvance)
                            
                            ranges = \
                                np.array(list(exemplar_points_and_labels.keys()))
                            
                            relevant = \
                                np.where(np.all([ranges[:, 0] <= int(frame_num),
                                                 ranges[:, 1] >= int(frame_num)],
                                                axis=0))[0]
            
                            if len(relevant) > 0:
                                
                                for rel in relevant:
                                    
                                    key = tuple(ranges[rel])
                                    
                                    for i, pts in enumerate(exemplar_points_and_labels[key][0]):
                                        
                                        descriptor = \
                                            exemplar_points_and_labels[key][1][i]
                                            
                                            
                                        color = [bgr for d, bgr in \
                                                 zip(['predominately head',
                                                      'predominately hand',
                                                      'predominately both'],
                                                       [(0, 0, 255),
                                                        (0, 255, 255),
                                                        (0, 127, 255)]) \
                                                        if d == descriptor]
                                                 
                                        descr = [d[14:] for d in \
                                                 ['predominately head',
                                                  'predominately hand',
                                                  'predominately both'] \
                                                  if d == descriptor]
                                                 
                                        if descr[0] == 'hand': 
                                                 
                                            cv2.rectangle(frame_to_display,
                                                          tuple(pts[0:2]),
                                                          tuple(pts[2:]),
                                                          color[0])
                                            
                                            cv2.rectangle(frame_to_display,
                                                          tuple(pts[0:2]),
                                                          tuple(pts[0:2] + \
                                                np.array([len(descr[0]) * 6, 9])),
                                                          color[0], -1)
                                                          
                                            cv2.putText(frame_to_display, descr[0],
                                                tuple(pts[0:2] + np.array([0, 6])),
                                                        cv2.FONT_HERSHEY_DUPLEX, 0.3,
                                                        (0, 0, 0), 1)
                                        
                    if place_patches == True: 
                                       
                        if len(patch_points_and_labels.keys()) > 0:
                            
                            frame_num = (count - framesToAdvance)
                            
                            ranges = \
                                np.array(list(patch_points_and_labels.keys()))
                            
                            relevant = \
                                np.where(np.all([ranges[:, 0] <= int(frame_num),
                                                 ranges[:, 1] >= int(frame_num)],
                                                axis=0))[0]
            
                            if len(relevant) > 0:
                                
                                for rel in relevant:
                                    
                                    key = tuple(ranges[rel])
                                        
                                    for i, pts in enumerate(patch_points_and_labels[key][0]):
                                        
                                        descriptor = \
                                            patch_points_and_labels[key][1][i]
                                            
                                            
                                        color = [bgr for d, bgr in \
                                                 zip(['predominately head',
                                                      'predominately hand',
                                                      'predominately both',
                                                      'predominately non-exemplar'],
                                                       [(0, 0, 0),
                                                        (255, 255, 0),
                                                        (0, 0, 0),
                                                        (0, 0, 0)]) \
                                                        if d == descriptor]
                                        
                                        descr = [d[14:] for d in \
                                                 ['predominately head',
                                                  'predominately hand',
                                                  'predominately both',
                                                  'predominately non-exemplar'] \
                                                  if d == descriptor]
                                        
#                                        print(descr[0])
#                                        if descr[0] != 'non-exemplar' and \
#                                           descr[0] != 'head' and \
#                                           descr[0] != 'both':
                                            
                                        cv2.rectangle(frame_to_display,
                                                      tuple(pts[0:2]),
                                                      tuple(pts[2:]),
                                                      color[0], 1)

                                        cv2.rectangle(frame_to_display,
                                            tuple(pts[0:2]), tuple(pts[0:2] + \
                                            np.array([pts[2]-pts[0], 9])),
                                            color[0], -1)
                                                  
                                        cv2.putText(frame_to_display, str(i),
                                            tuple(pts[0:2] + np.array([0, 6])),
                                            cv2.FONT_HERSHEY_DUPLEX, 0.3,
                                            (0, 0, 0), 1)
                                                
                                            
    #                                    elif i in might_fix_indices:
    #                                        
    #                                        cv2.rectangle(frame_to_display,
    #                                                      tuple(pts[0:2]),
    #                                                      tuple(pts[2:]),
    #                                                      color[0])
    #
    #                                        cv2.rectangle(frame_to_display,
    #                                            tuple(pts[0:2]), tuple(pts[0:2] + \
    #                                            np.array([pts[2]-pts[0], 9])),
    #                                            color[0], -1)
    #                                                  
    #                                        cv2.putText(frame_to_display, descr[0],
    #                                            tuple(pts[0:2] + np.array([0, 6])),
    #                                            cv2.FONT_HERSHEY_DUPLEX, 0.3,
    #                                            (255, 187, 0), 1)
    
                                        
                    if place_classified_patches == True: 
                                       
                        if len(patch_points_and_classified_labels.keys()) > 0:
                            
                            frame_num = (count - framesToAdvance)
                            
                            ranges = \
                                np.array(list(patch_points_and_classified_labels.keys()))
                            
                            relevant = \
                                np.where(np.all([ranges[:, 0] <= int(frame_num),
                                                 ranges[:, 1] >= int(frame_num)],
                                                axis=0))[0]
            
                            if len(relevant) > 0:
                                
                                for rel in relevant:
                                    
                                    key = tuple(ranges[rel])
                                        
                                    for i, pts in enumerate(\
                                patch_points_and_classified_labels[key][0]):
                                        
                                        descriptor = \
                                patch_points_and_classified_labels[key][1][i]
                                            
                                            
                                        color = [bgr for d, bgr in \
                                                 zip(['pruned',
                                                      'classifed-non-hand',
                                                      'classifed-hand'],
                                                       [(0, 0, 0),
                                                        (56, 38, 35),
                                                        (188, 13, 162)]) \
                                                        if d == descriptor]
                                        
                                        descr = [ds for d, ds in \
                                                 zip(['pruned',
                                                      'classifed-non-hand',
                                                      'classifed-hand'],
                                                     ['pruned',
                                                      'non-hand',
                                                      'hand'])\
                                                  if d == descriptor]
                                        
#                                        print(descr[0])
                                        if descr[0] == 'hand' or descr[0] == 'non-hand':
                                            
                                            cv2.rectangle(frame_to_display,
                                                          tuple(pts[0:2]),
                                                          tuple(pts[2:]),
                                                          color[0])
    
                                            cv2.rectangle(frame_to_display,
                                                tuple(pts[0:2]), tuple(pts[0:2] + \
                                                np.array([pts[2]-pts[0], 9])),
                                                color[0], -1)
                                                      
                                            cv2.putText(frame_to_display, str(i),
                                                tuple(pts[0:2] + np.array([0, 6])),
                                                cv2.FONT_HERSHEY_DUPLEX, 0.3,
                                                (0, 0, 0), 1)                                        

                    if place_wenjing == True and (count - 4) % 36 == 0:
                        
                        # face
                        
                        cleaned_skin_mask = np.any(cleaned_skin > 50, axis=2)
                        
                        
                        am_skin_union = np.all([cleaned_skin_mask,
                                                face_mask[:, :, 0]], axis=0)
                                                     
                        cc = cv2.connectedComponentsWithStats(\
                            am_skin_union.astype(np.uint8))                             
                        
                        am_skin_union_sig_area = np.any([cc[1] == label \
                            for label in np.arange(1, cc[0]) \
                            if cc[2][label, cv2.CC_STAT_AREA] > 200], axis=0)
                                                     
                        cc2 = cv2.connectedComponentsWithStats(\
                            am_skin_union_sig_area.astype(np.uint8))

                        for row in cc2[2][1:]:
                            print(row)
                            cv2.rectangle(frame_to_display,
                                          (row[cv2.CC_STAT_LEFT],
                                           row[cv2.CC_STAT_TOP]),
                                          (row[cv2.CC_STAT_LEFT] + \
                                           row[cv2.CC_STAT_WIDTH] - 1,
                                           row[cv2.CC_STAT_TOP] + \
                                           row[cv2.CC_STAT_HEIGHT] -1),
                                           (0, 0, 178), 1)
                                          
                        # back
                        
                        cc_back = \
                            cv2.connectedComponentsWithStats(back_mask[:, :, 0])
                        if cc_back[0] > 1:
                            cv2.rectangle(frame_to_display,
                                        (cc_back[2][1, cv2.CC_STAT_LEFT],
                                         cc_back[2][1, cv2.CC_STAT_TOP]),
                                        (cc_back[2][1, cv2.CC_STAT_LEFT] + \
                                         cc_back[2][1, cv2.CC_STAT_WIDTH] - 1,
                                         cc_back[2][1, cv2.CC_STAT_TOP] + \
                                         cc_back[2][1, cv2.CC_STAT_HEIGHT] -1),
                                        (0, 178, 0), 1)
                                        
                        # boy back
                        cc_boy_back = \
                            cv2.connectedComponentsWithStats(boy_back_mask[:, :, 0])
                        if cc_boy_back[0] > 1:
                            cv2.rectangle(frame_to_display,
                                    (cc_boy_back[2][1, cv2.CC_STAT_LEFT],
                                     cc_boy_back[2][1, cv2.CC_STAT_TOP]),
                                    (cc_boy_back[2][1, cv2.CC_STAT_LEFT] + \
                                     cc_boy_back[2][1, cv2.CC_STAT_WIDTH] - 1,
                                     cc_boy_back[2][1, cv2.CC_STAT_TOP] + \
                                     cc_boy_back[2][1, cv2.CC_STAT_HEIGHT] -1),
                                    (178, 0, 0), 1)                        
                                              
                        
                                
                    cv2.imshow(title, frame_to_display)
        
                saved_frames.append(frame_to_display)
                
                if reduced_frames == True:
                    frame_number.append(str((count - framesToAdvance) * 4))
                else:
                    frame_number.append(str(count - framesToAdvance))
                
                if len(saved_frames) > number_saved:
                    saved_frames.pop(0)
                    frame_number.pop(0)
                else:
                    ind = ind + 1
        
        
                # update frame1
                frame1 = frame2
                
            else:
                # draw the text
                cv2.putText(saved_frames[-1], 'last', (25, 25),
                            cv2.FONT_HERSHEY_SIMPLEX, 1, (0, 255, 0), 2)
                
                cv2.imshow(title, saved_frames[-1])
                
                    
            # Esc key press will escape
            k = cv2.waitKey(1) & 0xff
            if k == 27:
    
                # release capture
                cap.release()
    
                # close all the OpenCV windows
                cv2.destroyAllWindows()
                
                break
            # space key will pause
            elif k == 32 or (segment == True and count % num_frames == 0):
        
                # allow scrolling
                k = -1
                    
                # until we get another space key
                allow_scrolling = True
    
                while(allow_scrolling):
                
                    k = cv2.waitKey(1)
                    
                    # space or escape
                    if k == 32 or k == 27:
                
                        allow_scrolling = False
                    
                    # > arrow
                    elif k == 46:
                
                        if ind < len(saved_frames) - 1:
                            
                            ind = ind + 1
                            cv2.imshow(title, saved_frames[ind])
                    
                    # < arrow
                    elif k == 44:
                        
                        if ind > 0:
                            
                            ind = ind - 1
                            cv2.imshow(title, saved_frames[ind])
    
    
                 
    #            According to "A Byte of Python", "The else block is executed when
    #            the while loop condition becomes False - this may even be the first
    #            time that the condition is checked. If there is an else clause for
    #            a while loop, it is always executed unless you break out of the
    #            loop with a break statement."
                
                else:
                    
                    # escape
                    if k == 27:
    
                        # release capture
                        cap.release()
            
                        # close all the OpenCV windows
                        cv2.destroyAllWindows()
                        
                        break
                    
                    # space
                    if k == 32:
                        
                        get_back = True
                        
                        while(get_back):
                            
                            if ind + 1 == len(saved_frames):
                                
                                get_back = False
                                
                            else:
                                
                                ind = ind + 1
                                
                                cv2.imshow(title, saved_frames[ind])
                                
                                k = cv2.waitKey(1)
                                
                                if k == 27:
                                    
                                    get_back = False
    
                        else:
                            
                            # escape
                            if k == 27:
            
                                # release capture
                                cap.release()
                    
                                # close all the OpenCV windows
                                cv2.destroyAllWindows()
                                
                                break                            
             
    else:

        # release capture
        cap.release()

        # close all the OpenCV windows
        cv2.destroyAllWindows()


e2 = cv2.getTickCount()
time = (e2 - e1)/ cv2.getTickFrequency()
print("Execution time in seconds = ", time)
