# -*- coding: utf-8 -*-
"""
Created on Sun May 20 15:07:05 2018

@author: Callie Darsey

get_Wenjing_head_detection_01
"""

import cv2
import numpy as np
import pickle
import matplotlib.pyplot as plt
import os
import scipy as sp
import scipy.ndimage
import subprocess
from sklearn.preprocessing import StandardScaler
from sklearn.neighbors import KNeighborsClassifier
from sklearn.metrics import accuracy_score
from scipy.ndimage.interpolation import shift
from sklearn.pipeline import Pipeline
import wenjing_01

if __name__ == '__main__':
    eit = cv2.getTickCount()
    
    names = [\
#    'STI_Polk_Apr27_A/MVI_0073_trans/',
#    'STI_Polk_May11_C/MVI_0108_trans/',
#    'STI_WA_Apr11_extra_B/MVI_0036_trans/',
#    'STI_WA_Jun12_B/MVI_0018_trans/',
#    'STI_WA_Jun14_Lb/MVI_0070_trans/',
#    'STI_WA_Jun20_CT/MVI_0029_trans/',
    'STI_WA_Jun22_De/MVI_0118_trans/',
    'STI_WA_Jun23_Da/MVI_0112_trans/',
    'STI_WA_May02_C/MVI_0074_trans/',
    'STI_WA_May09_A/MVI_0109_trans/',
    'STI_Polk_Apr27_D/MVI_0063_trans/',
    'STI_WA_May02_B/MVI_0053_trans/',         
    'part1/MVI_0069_trans/',
    'STI_Polk_Apr13_C/MVI_0039_trans/',
    'STI_Polk_May04_A/MVI_0087_trans/',]
    
    for folder in names:
        print(folder)
       
        e1 = cv2.getTickCount()
        
        directory = "./wheeler/dataset/" + folder
        
        for content in os.listdir(directory):
            
            if os.path.isfile(directory + content):
                
                if content[-12:] == '.sampled.mp4':
                    
                    name = content[:-12]
                    
                    print(name)
                    
                    break
                                           
        cap_frame = cv2.VideoCapture(directory + name + '.sampled.mp4')
        
        cols = int(cap_frame.get(cv2.CAP_PROP_FRAME_WIDTH))
        rows = int(cap_frame.get(cv2.CAP_PROP_FRAME_HEIGHT))
        
        # videos to write to
        fourcc = cv2.VideoWriter_fourcc(*'XVID')
        
        cap_face = cv2.VideoWriter(\
            directory + name + '.wenjing_face_detections.mp4',
            cv2.CAP_FFMPEG, fourcc, 1.67, (cols, rows))
        
        cap_back = cv2.VideoWriter(\
            directory + name + '.wenjing_back_detections.mp4',
            cv2.CAP_FFMPEG, fourcc, 1.67, (cols, rows))
        
        cap_boy_back = cv2.VideoWriter(\
            directory + name + '.wenjing_boy_back_detections.mp4',
            cv2.CAP_FFMPEG, fourcc, 1.67, (cols, rows))
    
        segment = 45
        
        detections_per_segment = 5
        
        count = -1
        
        while cap_frame.isOpened():
            
            success_flag_frame, frame = cap_frame.read()
            
            if success_flag_frame == True:
                
                count = count + 1
    
    
                if count % (segment / detections_per_segment) == 0:
                    
                    ei = cv2.getTickCount()
                    
                    rows, cols, channels = frame.shape
                    
                    frame_left, frame_right = frame[:, 0: rows, :], frame[:, -rows:, :]
                    
                    name = 'tmp.'
                    
                    file_left = directory + name + 'left.png'
                    file_right = directory + name + 'right.png'
                    
                    cv2.imwrite(file_left, frame_left)
                    cv2.imwrite(file_right, frame_right)
                    
                    executable = \
                        "../VisualStudio/Gabor_by_Wenjing_Shi/x64/Release/" + \
                        "Gabor_by_Wenjing_Shi.exe"
                        
                    subprocess.call([executable, file_left])
                    subprocess.call([executable, file_right])
                    
                    file_mag_left = directory + name + 'left.mag.png'
                    file_phas_left = directory + name + 'left.phas.png'
                    
                    file_mag_right = directory + name + 'right.mag.png'
                    file_phas_right = directory + name + 'right.phas.png'
                    
                    mag_left = cv2.imread(file_mag_left)
                    phas_left = cv2.imread(file_phas_left)
                    
                    mag_right = cv2.imread(file_mag_right)
                    phas_right = cv2.imread(file_phas_right)
                    
                    stitched_mag, stitched_mag_resized = \
                        wenjing_01.stitch(mag_left, mag_right, frame)
                        
                    stitched_phas, stitched_phas_resized = \
                        wenjing_01.stitch(phas_left, phas_right, frame)
                    
                    with open('./wheeler/svc/all_train_data1.pkl', 'rb') as f:
                        all_train_data1 = pickle.load(f)
                    
                    with open('./wheeler/svc/label_train_data1.pkl', 'rb') as f:
                        label_train_data1 = pickle.load(f)
                    
                    K=3
                    knn_clf = KNeighborsClassifier(n_jobs=-1, weights='distance',
                                                   n_neighbors=K)    
                    knn_clf.fit(all_train_data1, label_train_data1.ravel())
                        
                    am_face_mask = wenjing_01.get_face_squares(\
                        stitched_phas_resized[:, :, 0], knn_clf)
                    
                    
                    am_face_mask_resized = cv2.resize(am_face_mask,
                        (stitched_phas.shape[1], stitched_phas.shape[0]))
                    
                    cap_face.write(np.stack([am_face_mask_resized,
                                             am_face_mask_resized,
                                             am_face_mask_resized], axis=2))
    
                    frame_downsized = cv2.resize(frame,
                        (stitched_phas.shape[1], stitched_phas.shape[0]))
                    
                    back_info = wenjing_01.backFM(frame_downsized,
                        stitched_mag_resized[:, :, 0],
                        stitched_phas_resized[:, :, 0], show=False)
                    
                    if back_info is not None:
                        
                        back_mask = np.zeros_like(stitched_mag_resized)
                    
                        cv2.rectangle(back_mask, (back_info[0], back_info[1]),
                            (back_info[0] + back_info[2],
                             back_info[1] + back_info[2]), (255, 255, 255), -1)
                
                        back_mask = cv2.resize(back_mask,
                            (stitched_phas.shape[1], stitched_phas.shape[0]))
                        
                        cap_back.write(back_mask)
                        
                    else:
                        
                        cap_back.write(np.zeros_like(stitched_mag))
                        
                    
                    boy_back_info = wenjing_01.backFM_boy(frame_downsized,
                        stitched_mag_resized[:, :, 0],
                        stitched_phas_resized[:, :, 0], show=False)
                    
                    if boy_back_info is not None:
                        
                        boy_back_mask = np.zeros_like(stitched_mag_resized)
                    
                        cv2.rectangle(boy_back_mask,
                            (boy_back_info[0], boy_back_info[1]),
                            (boy_back_info[0] + boy_back_info[2],
                             boy_back_info[1] + boy_back_info[2]),
                             (255, 255, 255), -1)
                                                     
                        boy_back_mask = cv2.resize(boy_back_mask,
                            (stitched_phas.shape[1], stitched_phas.shape[0]))
                        
                        cap_boy_back.write(boy_back_mask)
                        
                    else:
                        
                        cap_boy_back.write(np.zeros_like(stitched_mag))
                    
                    ee = cv2.getTickCount()
                    print('Execution time per frame: {:.1f}'.format(\
                          (ee - ei) / cv2.getTickFrequency()))                
                    
                  
            else:
                
                print("No more frames")
                
                cap_frame.release()
                cap_face.release()
                cap_back.release()
                cap_boy_back.release()
                        
                break        
    
            
        e2 = cv2.getTickCount()
        time = (e2 - e1)/ cv2.getTickFrequency()
        print("Execution time for video in seconds = ", time)
        
    eet = cv2.getTickCount()
    time = (eet - eit)/ cv2.getTickFrequency()
    print("Total execution time in seconds = ", time)    
