# -*- coding: utf-8 -*-
"""
Created on Mon Dec  4 19:33:55 2017

@author: Callie Darsey (cj.darsey@gmail.com)

When run, this script copies another AOLME video fro
"""

import json
from ftplib import FTP_TLS
import numpy as np
import cv2
from matplotlib import pyplot as plt
import pickle
import os

# names of .json file used for storage
ftp_loc_mp4 = './video_copies_clips_track/track_aolme1_entry/ftp_loc_mp4.json'

ftp_loc_mp4_visited = './video_copies_clips_track/track/ftp_loc_mp4_visited.json'

# I move by hand info for videos not of interest to this file
ftp_loc_mp4_visited_not_useful = './video_copies_clips_track/track/' + \
                                 'ftp_loc_mp4_visited_not_useful.json'

# semester I'm focusing on
key = 'Spring2017'
master_key = 'ftp'

# load the dictionaries from the .json files
with open(ftp_loc_mp4, 'r') as f:
    loc_dic = json.load(f)
    
with open(ftp_loc_mp4_visited, 'r') as f:
    visited_loc_dic = json.load(f)
    
with open(ftp_loc_mp4_visited_not_useful, 'r') as f:
    not_useful_loc_dic = json.load(f)
    

# randomly choose an .mp4 video on the ftp (that I have not processed before)    
num_mp4 = len(loc_dic[master_key])

# make sure we haven't visited or vetoed it 
while True:
    
    random_number = np.random.randint(num_mp4)
    print('random number: ', random_number)
    
    ftp_loc = loc_dic[master_key][random_number]
    
    path, mp4name = os.path.split(ftp_loc)
    
    print('path', path)
    print('mp4name', mp4name)
    
    if ftp_loc not in visited_loc_dic[key] and \
       ftp_loc not in not_useful_loc_dic[key] and \
       mp4name[0:4] != '2016' and  \
       mp4name[0:4] != '2017' and \
       'Spring2017' not in path:
           
        break

higher_path, deepest_folder = os.path.split(path)

# copy the .mp4 from the ftp
ftp = FTP_TLS("129.24.28.223")
print("Welcome: ", ftp.getwelcome())
ftp.auth()
ftp.prot_p()
ftp.login(user='cdarsey', passwd='xyz123693')

ftp.cwd(path)

holding_dir = os.path.join( \
    './video_copies_clips_track/copies_and_clips_wave_04/', deepest_folder)

if not os.path.isdir(holding_dir):
    os.mkdir(holding_dir)

if not os.path.isdir(os.path.join(holding_dir, mp4name[:-4])):
    os.mkdir(os.path.join(holding_dir, mp4name[:-4]))
    
filedata = open(os.path.join(holding_dir, mp4name), 'wb') 
ftp.retrbinary('RETR '+mp4name, filedata.write) 
filedata.close() 

ftp.quit()

# record that mp4 on the ftp as visited  
print(ftp_loc)
visited_loc_dic[key].append(ftp_loc)

# save the new visited dictionary to the .json file
with open(ftp_loc_mp4_visited, 'w') as f:
    json.dump(visited_loc_dic, f)

# finish with a print statement
video_path = holding_dir+ '/'+mp4name
print(video_path)

# look at the fps
cap = cv2.VideoCapture(video_path)

fps = cap.get(cv2.CAP_PROP_FPS )
print('frames per second:', fps)

# release capture
cap.release()