# -*- coding: utf-8 -*-
"""
Created on Thu Apr  5 16:48:18 2018

@author: Callie Darsey

plot max motion per frame on thresholded frame intersected with
skin detection
"""

import skin_detector_01 as skin_detector
import get_lessened_features_and_save_steps_01 as get
import cv2
import numpy as np
import matplotlib.pyplot as plt
import pickle



# video path
common_path = './video_copies_clips_track/copies_and_clips_facilitator_C/'
specific_path = 'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__200_208/'
video_name = 'MVI_0028_trans__200_208.mp4'



regions_path = 'adjust_review_03/region_masks/'

collect_max_flow_mag_per_frame = []
collect_flow_mag_sum_per_frame = []
union_mask = []

step = 4
union_size = 10
fn_largest = 460

frame_values = \
    np.concatenate([np.arange(0, fn_largest + step, union_size * step),
                    np.array([fn_largest + step])])
    
ranges = np.hstack([frame_values[0:-1].reshape((-1, 1)),
                    frame_values[1:].reshape((-1, 1))])

for rng in ranges:
    
    print(rng[0], ',', rng[1])
    
    # prep window
    title = 'display window'
    move_window = [0, -30]
    cv2.namedWindow(title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
    cv2.moveWindow(title, move_window[0], move_window[1])

    count = 0
    
    # collect gray frames
    collect_Y = []
    
    # collect thresholded magnitude frames
    thresh = 7.0
    collect_threshold_flow_mag = []
    
    #for f1n in range(0, 464, 4):
    for f1n in range(rng[0], rng[1], step):
        
        count = count + 1
    
        flow_name = 'flow_MVI_0028_trans__200_208_' + '{:04d}'.format(f1n) + \
                     '_' + '{:04d}'.format(f1n + 4) + '.data'
        
        # load pickled flow    
        with open(common_path + specific_path + flow_name, 'rb') as f:
            p = pickle.load(f)
        frame1, frame2, flow, = p[0], p[1], p[2]
            
        # gray
        Y = cv2.cvtColor(frame1, cv2.COLOR_BGR2GRAY)
        collect_Y.append(Y)
            
        # calc flow mag sum
        flow_mag = cv2.magnitude(flow[:, :, 0], flow[:, :, 1])
        
        # threshold
        flow_mag_thresh = np.copy(flow_mag)
        flow_mag_thresh[flow_mag < thresh] = 0.0
        collect_threshold_flow_mag.append(flow_mag_thresh)
        
    #    # threshold flow mag. mask
    #    flow_mask, bp1_thresh, bp2_thresh, flow_mag_thresh, bp1, bp2 = \
    #        get.get_threshold_flow_mask(flow_mag)
                
        
    #    # skin mask
    #    skin_mask = skin_detector.DetectSkinRegions(frame1)
        
    #    # keep only the thresholded components overlaping skin
    #    connectivity = 4
    #    cc_flow = cv2.connectedComponents(flow_mask.astype(np.uint8),
    #                                      connectivity, cv2.CV_32S)
    #    
    #    collect = []
    #    for label in range(1, cc_flow[0]):
    #        
    #        comp_mask = (cc_flow[1] == label)
    #        
    #        if np.count_nonzero(np.all([comp_mask, skin_mask], axis=0)):
    #            
    #            collect.append(comp_mask)
    #        
    #        
    #    remaining_thr_flow_mag_mask = np.any(collect, axis=0)
    #    
    #    # threshold flow
    #    thr_flow_mag = np.copy(flow_mag)
    #    thr_flow_mag[remaining_thr_flow_mag_mask == False] = 0.0
        
        
    
    
    
    #    # draw flow arrows
    #    arrows = np.copy(frame1)
    #    fns.draw_flow(arrows, flow, (flow_mag != 0.0), step=4)    
        
        # print    
        # print('{:04d}'.format(f1n), np.count_nonzero(thr_flow_mag == 0.0))
        
    #    print('{:04d}'.format(f1n),
    #          'bp1_whisker_thresh: {:.2f}'.format(bp1_thresh),
    #          'bp2_median_thresh: {:.2f}'.format(bp2_thresh))
    
        # not thresholding magnitude
        thr_flow_mag = flow_mag
        
        if count == 1:
            
            flow_mag_sum = np.copy(thr_flow_mag)
        
        else:
            
            flow_mag_sum = flow_mag_sum + thr_flow_mag
    
    #    # cumulative sum of skin masks    
    #    if f1n == 0:
    #        
    #        skin_mask_sum = np.copy(skin_mask).astype(np.uint32)
    #    
    #    else:
    #        
    #        skin_mask_sum = skin_mask_sum + skin_mask    
        
        # collect
        collect_max_flow_mag_per_frame.append(np.max(thr_flow_mag))
        collect_flow_mag_sum_per_frame.append(np.sum(flow_mag))
        
#        # for display
#        flow_mag_display = \
#            (255 * flow_mag_thresh / np.max(flow_mag_thresh)).astype(np.uint8)
#        flow_mag_display_C3 = np.stack([flow_mag_display,
#                                        flow_mag_display,
#                                        flow_mag_display], axis=2)
#        
#        # draw the text
#        cv2.putText(flow_mag_display_C3, str(int(f1n)),
#                    (flow_mag_display_C3.shape[1] - 100, 25),
#                    cv2.FONT_HERSHEY_SIMPLEX, 1, (0, 255, 0), 2) 
#        
#        cv2.imshow(title, flow_mag_display_C3)
#    
#    
#        
#        k = cv2.waitKey(1)
#        if k == 27:
#            break
#    
#    cv2.destroyAllWindows()

    
    # sum gray frame
    Y_sum = np.sum(collect_Y, axis=0)
    
    Y_sum_display = (255 * Y_sum / np.max(Y_sum)).astype(np.uint8)

        
    # for display of flow magnitude accumulated sum
    flow_mag_sum_display = \
        (255 * flow_mag_sum / np.max(flow_mag_sum)).astype(np.uint8)
        
#    # canny edge
#    minVal = 50
#    maxVal = 150
#    edges = cv2.Canny(flow_mag_sum_display, minVal, maxVal)
        
    # threshold
    thr = 25
        
    # threshold     
    thr_flow_mag_sum = np.copy(flow_mag_sum)
    thr_flow_mag_sum[thr_flow_mag_sum < thr] = 0.0
    
    thr_flow_mag_sum_display = \
        (255 * thr_flow_mag_sum / np.max(thr_flow_mag_sum)).astype(np.uint8)
        
    # intersection
    intersection = \
        255 * np.all(collect_threshold_flow_mag, axis=0).astype(np.uint8)
    
    # union
    union = \
        255 * np.any(collect_threshold_flow_mag, axis=0).astype(np.uint8)


    union_mask.append((rng[0], rng[1], step, union))

        
#    # Gaussian blur
#    gb_flow_mag_sum = cv2.GaussianBlur(flow_mag_sum, (5, 5), sigmaX=3, sigmaY=3)
#    
#    gb_flow_mag_sum_display = \
#        (255 * gb_flow_mag_sum / np.max(gb_flow_mag_sum)).astype(np.uint8)
        
#    # canny edge on Gaussian blur
#    minVal = 50
#    maxVal = 150
#    edges_gb = cv2.Canny(gb_flow_mag_sum_display, minVal, maxVal)
    
#    # threshold Gaussian blur
#    thr_gb_flow_mag_sum = np.copy(gb_flow_mag_sum)
#    thr_gb_flow_mag_sum[gb_flow_mag_sum < thr] = 0.0
#    
#    thr_gb_flow_mag_sum_display = \
#        (255 * thr_gb_flow_mag_sum / np.max(thr_gb_flow_mag_sum)).astype(np.uint8)
        
    ## max in neighborhood
    #max_in_neigh = get.is_max_in_neighborhood(gb_flow_mag_sum, 20)
    #max_in_neigh_gb_flow_mag_sum = np.copy(gb_flow_mag_sum)
    #max_in_neigh_gb_flow_mag_sum[max_in_neigh == False] = 0.0
    #
    #max_in_neigh_gb_flow_mag_sum_display = \
    #    (255 * max_in_neigh_gb_flow_mag_sum / \
    #     np.max(max_in_neigh_gb_flow_mag_sum)).astype(np.uint8)
        
#    for tle, display in zip(['Y sum',
#                             'acc. sum flow mag.',
#                             'threshold acc. sum flow mag.',
#                             'interesction',
#                             'union'
#                             ],
#                             [Y_sum_display,
#                              flow_mag_sum_display,
#                              thr_flow_mag_sum_display,
#                              intersection,
#                              union
#                              ]):
#        
#        # prep window
#        move_window = [0, -30]
#        cv2.namedWindow(tle, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
#        cv2.moveWindow(tle, move_window[0], move_window[1])
#        
#        cv2.imshow(tle, display)
#    
#        
#    cv2.waitKey(0)
#    cv2.destroyAllWindows()
    for tle, display in zip(['Y sum',
                             'acc. sum flow mag.',
                             'union'
                             ],
                             [Y_sum_display,
                              flow_mag_sum_display,
                              union
                              ]):
        
        # prep window
        move_window = [0, -30]
        cv2.namedWindow(tle, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
        cv2.moveWindow(tle, move_window[0], move_window[1])
        
        cv2.imshow(tle, display)
    
        
    cv2.waitKey(0)
    cv2.destroyAllWindows()

# save union, and the range[a, b) and step
with open(common_path + specific_path + video_name[0:-4] + \
          '_union_masks.data', 'wb') as f:
    
    pickle.dump((union_mask), f)



## display blur of sum
#gb_flow_mag_sum = cv2.GaussianBlur(flow_mag_sum, (11, 11), sigmaX=5, sigmaY=5)
#        
## prep window
#title_blur = 'blur sum'
#move_window = [0, -30]
#cv2.namedWindow(title_blur, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
#cv2.moveWindow(title_blur, move_window[0], move_window[1])
#
#gb_flow_mag_sum_display = \
#    (255 * gb_flow_mag_sum / np.max(gb_flow_mag_sum)).astype(np.uint8)
#
#cv2.imshow(title_blur, gb_flow_mag_sum_display)
#
#bpsum = plt.boxplot(gb_flow_mag_sum.reshape((-1, 1)))
#plt.show()
#
#
### prep window
##title_tophat = 'display window tophot'
##move_window = [0, -30]
##cv2.namedWindow(title_tophat, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
##cv2.moveWindow(title_tophat, move_window[0], move_window[1])
##
##tophat_flow_mag_sum = cv2.morphologyEx(gb_flow_mag_sum, cv2.MORPH_TOPHAT,
##                                       np.ones((31, 31)))
##
##tophat_flow_mag_sum_display = \
##    (255 * tophat_flow_mag_sum / np.max(tophat_flow_mag_sum)).astype(np.uint8)
##
##cv2.imshow(title_tophat, tophat_flow_mag_sum_display)
#
#cv2.waitKey(0)
#
#        
#cv2.destroyAllWindows()
#
## plot max flow mag
#plt.figure(figsize=(20, 3))
#plt.xticks(np.arange(0, 464, 4), rotation=90)
#plt.ylabel('max flow mag')
#plt.xlabel('frame')
#plt.plot(np.arange(0, 464, 4), collect_max_flow_mag_per_frame, marker='.')
#
## convert to numpy array
#max_flow_mag_per_frame = np.array(collect_max_flow_mag_per_frame)
#
#
## peak
#for ker_sz in [5]:
#    
#    kernel = np.ones((ker_sz, ker_sz))
#    
#    top_hat = cv2.morphologyEx(max_flow_mag_per_frame, cv2.MORPH_TOPHAT,
#                               kernel)
#        
#    plt.figure(figsize=(20, 3))
#    plt.xticks(np.arange(0, 464, 4), rotation=90)
#    plt.title('kernel size {} x {}'.format(ker_sz, ker_sz))
#    plt.ylabel('tophat')
#    plt.xlabel('frame')
#    plt.plot(np.arange(0, 464, 4), top_hat, marker='.')
#
#plt.show()

action_frames = [[0, 24], [36], [52,84], [108,124], [176,188], [364, 412],
                 [420, 428], [84], [172], [256, 308], [316], [324, 332],
                 [388, 460], [28, 56], [180, 220], [244, 292], [264, 300],
                 [156, 172], [180, 200], [224, 234], [152, 160], [188, 192],
                 [204, 208], [228, 248], [256, 264], [272, 280], [288, 296],
                 [304], [320, 328], [344]]

action_frame_numbers = []

for rng in action_frames:
    
    if len(rng) == 1:
        
        action_frame_numbers.append(rng[0])
        
    elif len(rng) == 2:
        
        action_frame_numbers.append(np.arange(rng[0], rng[1] + 1, 4))
        
    else:
        
        print('huh?')
        
unique_afn = np.unique(np.hstack(action_frame_numbers))

no_strong_action = []

for fn in np.arange(0, 461, 4):
    
    if fn not in unique_afn:
        
        no_strong_action.append(fn)
        
lows = []
for ind in no_strong_action:
    
    lows.append(collect_max_flow_mag_per_frame[int(ind / 4)])

alows = np.array(lows)

print('min', np.min(alows))
print('mean', np.mean(alows))
print('median', np.median(alows))
print('max', np.max(alows))


## force low to 0.0
#thresh_to_zero = np.copy(max_flow_mag_per_frame)
#thresh_to_zero[max_flow_mag_per_frame <= np.max(alows)] = 0.0
#
#plt.figure(figsize=(20, 3))
#plt.xticks(np.arange(0, 464, 4), rotation=90)
#plt.title('thresh to zero'.format(ker_sz, ker_sz))
#plt.ylabel('tophat')
#plt.xlabel('frame')
#plt.plot(np.arange(0, 464, 4), thresh_to_zero, marker='.')
#
## peak
#for ker_sz in [5]:
#    
#    kernel = np.ones((ker_sz, ker_sz))
#    
#    top_hat = cv2.morphologyEx(thresh_to_zero, cv2.MORPH_TOPHAT, kernel)
#        
#    plt.figure(figsize=(20, 3))
#    plt.xticks(np.arange(0, 464, 4), rotation=90)
#    plt.title('kernel size {} x {}'.format(ker_sz, ker_sz))
#    plt.ylabel('tophat')
#    plt.xlabel('frame')
#    plt.plot(np.arange(0, 464, 4), top_hat, marker='.')
#
