# -*- coding: utf-8 -*-
"""
Created on Sat May  5 20:34:09 2018

@author: Callie Darsey

save_flow_mag_and_angle_in_video_wheeler_01
"""

import cv2
import pickle
import numpy as np
import os

def function():
    
    eb = cv2.getTickCount()
    
    # video path
    common_path = './'
    flow_folder = 'flow/'
    
    pickled_flow_paths = \
        [common_path + flow_folder + data_file \
         for data_file in os.listdir(common_path + flow_folder)]
    
    name = pickled_flow_paths[0][7:-15]
    
    with open(pickled_flow_paths[0], 'rb') as f:
        flow = pickle.load(f)
    
    '''
    We will sample the video.
    Write frames with cleaned skin detection.
    Write sampled frames to a video.
    '''
    fourcc = cv2.VideoWriter_fourcc(*'XVID')
    
    out_flow_mag = \
        cv2.VideoWriter(common_path +  name + '.flow_mag.mp4',
                        fourcc, 15, flow[:, :, 0].shape[-1::-1])
    out_flow_ang = \
        cv2.VideoWriter(common_path + name + '.flow_ang.mp4',
                        fourcc, 15, flow[:, :, 0].shape[-1::-1])


    for pickled_flow_path in pickled_flow_paths:  
    
        with open(pickled_flow_path, 'rb') as f:
            flow = pickle.load(f)
            
        flow_mag = cv2.magnitude(flow[:, :, 0], flow[:, :, 1])
        flow_ang = cv2.phase(flow[:, :, 0], flow[:, :, 1], angleInDegrees=True)
        
        '''
        x_scaled = \
            (x - x_min) * (x_scaled_max - x_scaled_min) / (x_max - x_min) + \
            x_scaled_min
        '''
        # flow angle
        flow_ang_minmax_normalized_truncated = \
            (flow_ang * (255.0 / 360.0)).astype(np.uint8)
            
        flow_ang_display = np.stack(\
            [flow_ang_minmax_normalized_truncated,
             flow_ang_minmax_normalized_truncated,
             flow_ang_minmax_normalized_truncated], axis=2)
        
        # flow magnitude
        flow_mag_clipped = np.copy(flow_mag)
        flow_mag_clipped[flow_mag > 50.0] = 50.0
        
        flow_mag_clipped_minmax_normalized_truncated = \
            (flow_mag_clipped * (255.0 / 50.0)).astype(np.uint8)
        
        flow_mag_display = np.stack(\
            [flow_mag_clipped_minmax_normalized_truncated,
             flow_mag_clipped_minmax_normalized_truncated,
             flow_mag_clipped_minmax_normalized_truncated], axis=2)
        
        out_flow_mag.write(flow_mag_display)
        out_flow_ang.write(flow_ang_display)

    out_flow_mag.release()
    out_flow_ang.release()

    ee = cv2.getTickCount()
    print('making flow videos {:.2f} seconds'.format(\
          (ee - eb)/ cv2.getTickFrequency()))        
