# -*- coding: utf-8 -*-
"""
Created on Thu Apr 12 12:07:36 2018

@author: Callie Darsey

save all the frames as png
"""

import cv2
import os


# video path
common_path = './video_copies_clips_track/copies_and_clips_wave_03/'
specific_path = 'STI WA May09 B/MVI_0006_trans/'
video_name = 'MVI_0006_trans__600_700.mp4'

video_path = common_path + specific_path + video_name

# make the review folder
review = common_path + specific_path + "PNGs/"
if not os.path.isdir(review):
    os.mkdir(review)

'''Frames to advance between frames passed to optical flow'''
framesToAdvance = 4

'''Resolution rescaling factor'''
scaleFactor = 0.67

      
# process the mp4 video
cap = cv2.VideoCapture(video_path)

num_frames = cap.get(cv2.CAP_PROP_FRAME_COUNT)
fps = cap.get(cv2. CAP_PROP_FPS )

print('number of frames:', num_frames)
print('frames per second:', fps)

print('framesToAdvance:', framesToAdvance)
print('scaleFactor:', scaleFactor)


# initialize frame1
success_flag, frame_full = cap.read()

assert success_flag, "On first attempt after construction, could \
                      not read frame from {}".format(video_path)  
                            
frame = cv2.resize(frame_full, (0,0), fx=scaleFactor, fy=scaleFactor) 

# loop through the frames

e1 = cv2.getTickCount()

count = 0

# save as png
cv2.imwrite(review + video_name[0:-4] + '_' + \
            '{:>04s}'.format(str(count)) + '.png', frame)

while(cap.isOpened()):
                
    # skip frames
    for i in range(framesToAdvance):
        success_flag, frame_full = cap.read()
        
        count += 1

        if (not success_flag):
            print("no more frames in this capture")
            break
     
    if success_flag:
        
        # resize
        frame = cv2.resize(frame_full, (0,0), fx=scaleFactor, fy=scaleFactor)
        
        # save as png
        cv2.imwrite(review + video_name[0:-4] + '_' + \
                    '{:>04s}'.format(str(count)) + '.png', frame)

    else:

        # release capture
        cap.release()


e2 = cv2.getTickCount()
time = (e2 - e1)/ cv2.getTickFrequency()
print("Execution time in seconds = ", time)
