# -*- coding: utf-8 -*-
"""
Created on Wed Apr 18 10:23:54 2018

@author: Callie Darsey
"""


import cv2
import numpy as np
import scipy.spatial.distance as scipy_dist

m = np.array([[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0],
              [0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0],
              [0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0],
              [0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0],
              [0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0],
              [0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 0],
              [0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0],
              [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0],
              [0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0],
              [0, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0],
              [0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
              [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]],
             dtype=np.uint8)


mb = np.zeros((300, 300), dtype=np.uint8)
mb[0:20, 0:24] = m

m, contours, hierarchy  = cv2.findContours(mb, cv2.RETR_TREE,
                                           cv2.CHAIN_APPROX_NONE)


for c in contours:
    print(c.shape)
    
for pt in contours[2]:
    print(pt)
    
cc_m = cv2.connectedComponents(m)

map_1 = (cc_m[1] == 1)

map_2 = np.copy(cc_m[1])
map_2[cc_m[1] == 1] = 0

cv2.imshow('map', m * 255)
cv2.imshow('map_1', map_1.astype(np.bool).astype(np.uint8) * 255)
cv2.imshow('map_2', map_2.astype(np.bool).astype(np.uint8) * 255)

cv2.waitKey(0)
cv2.destroyAllWindows()

#'''These are OpenCV functions that help in calculating the shortest distance'''
#map_contours_idx, hierarchy   = cv2.findContours(map_img_copy, cv2.RETR_TREE,
#                                                 cv2.CHAIN_APPROX_SIMPLE)
## Building ch_img contour
#ch_contours_idx, hierarchy    = cv2.findContours(ch_img_copy, cv2.RETR_TREE,
#                                                 cv2.CHAIN_APPROX_SIMPLE)
#map_cnt_idx = np.squeeze(np.concatenate(np.array(map_contours_idx)))
#ch_cnt_idx  = np.squeeze(np.concatenate(np.array(ch_contours_idx)))
#all_dist    = scipy_dist.cdist(map_cnt_idx,ch_cnt_idx,'euclidean')
#sd          = np.amin(all_dist)

map_1, map_1_contours, hierarchy_1 = \
    cv2.findContours(map_1.astype(bool).astype(np.uint8),
                     cv2.RETR_TREE, cv2.CHAIN_APPROX_NONE)
    
map_2, map_2_contours, hierarchy_2 = \
    cv2.findContours(map_2.astype(bool).astype(np.uint8),
                     cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
    
map_1_points = np.squeeze(np.concatenate(np.array(map_1_contours)))
map_2_points = np.squeeze(np.concatenate(np.array(map_2_contours)))

all_dist = scipy_dist.cdist(map_1_points,map_2_points, 'euclidean')

shortest_distance = np.amin(all_dist)
print(shortest_distance)

rows, cols = np.where(all_dist == shortest_distance)
print(rows, cols)

points = np.vstack([map_2_points[i, :] for i in cols])
print(points)


















