# -*- coding: utf-8 -*-
"""
Created on Mon May 14 20:18:58 2018

@author: Callie Darsey

subset_flow_mag_ang_sum_01_wheeler
"""

import cv2
import numpy as np
import pickle
import matplotlib.pyplot as plt
import os


def function(bin_size=32):
    '''
    '''
   
    e1 = cv2.getTickCount()
    
    directory = "./"
    
    for content in os.listdir(directory):
        
        if os.path.isfile(directory + content):
            
            if content[-12:] == '.sampled.mp4':
                
                name = content[:-12]
                
                print(name)
                
                break
                                       
    cap_flow_mag = cv2.VideoCapture(directory+'flow_'+name+'.flow_mag.mp4')
    cap_flow_ang = cv2.VideoCapture(directory+'flow_'+name+'.flow_ang.mp4')


    with open(directory + 'patches_info___' + name + '.data', 'rb') as f:
        
        patches_and_labels = pickle.load(f)
        
    keys = np.array(list(patches_and_labels.keys()))
    

    patches_and_labels_and_feature_feature_flow_mag_sum = {}
    patches_and_labels_and_feature_feature_flow_mag_sum_all = {}
    patches_and_labels_and_feature_feature_flow_sum_all_mag = {}
    patches_and_labels_and_feature_feature_flow_ang_sum = {}
    patches_and_labels_and_feature_feature_flow_sum_all_ang = {}

    
    fdicts = [patches_and_labels_and_feature_feature_flow_mag_sum,
              patches_and_labels_and_feature_feature_flow_mag_sum_all,
              patches_and_labels_and_feature_feature_flow_sum_all_mag,
              patches_and_labels_and_feature_feature_flow_ang_sum,
              patches_and_labels_and_feature_feature_flow_sum_all_ang]
    
    ftags = ['feature_flow_mag_sum',
             'feature_flow_mag_sum_all',
             'feature_flow_sum_all_mag',
             'feature_flow_ang_sum',
             'feature_flow_sum_all_ang']


    segment = 45
    
    segment_flow_mag = []
    segment_flow_ang = []
    
    count = -1
    ind = -1
    
    while(cap_flow_mag.isOpened() and cap_flow_ang.isOpened()):
        
        success_flag_flow_mag, flow_mag_display    = cap_flow_mag.read(0)
        success_flag_flow_ang, flow_ang_display     = cap_flow_ang.read(0)
        
        if success_flag_flow_mag == True and success_flag_flow_ang == True:
            
            count = count + 1
            
            rows, cols, channels = flow_mag_display.shape


            segment_flow_mag.append(flow_mag_display[:, :, 0])
            segment_flow_ang.append(flow_ang_display[:, :, 0])
    
        
            if len(segment_flow_mag) > segment:
                segment_flow_mag.pop(0)
                segment_flow_ang.pop(0)
    
            else:
                ind = ind + 1
    
    
            if count != 0 and (count + 1) % segment == 0:
                
                print('segment', int(np.floor(count / segment)))
    
                # find if segment has exemplars to collect features for
                index = np.where(keys[:, 1] == count * 4)[0]
    
                if len(index) == 1:
                    
                    # key for the segment
                    relevant_key = (keys[index[0], 0], keys[index[0], 1])
                    
                    # patch box info (and tags) for the segment
                    patches, tags = patches_and_labels[relevant_key]
    
                    # get the patch size
                    col_1, col_2 = np.sort([patches[0][0], patches[0][2]])
                
                    row_1, row_2 = np.sort([patches[0][1], patches[0][3]])
                    
                    patch_size = (row_2 - row_1 + 1, col_2 - col_1 + 1)
                    
    
                    '''operations on the  full frames over the segment'''

                    # flow mag sum divided by number of frames
                    flow_mag_sum = (np.sum(segment_flow_mag, axis=0) / 45)
                    
                    # flow ang sum divided by number of frames
                    flow_ang_sum = (np.sum(segment_flow_ang, axis=0) / 45)
                    
                    # flow ang. radians block
                    flow_ang_radians_block = np.stack(segment_flow_ang,
                        axis=2) * (360 / 255) * (np.pi / 180)
                    
                    # flow mag. block
                    flow_mag_block = np.stack(segment_flow_mag, axis=2)
                    
                    # x projection
                    x_projection = \
                        flow_mag_block * np.cos(flow_ang_radians_block)
                        
                    # y projection
                    y_projection = \
                        flow_mag_block * np.sin(flow_ang_radians_block)
                        
                    
                    
                    
    
                    '''
                    ***********************
                    features to collect
                    ***********************
                    '''
                    
                    ''' location normalized '''                
                    
                    ''' flow mag sum image '''
                    feature_flow_mag_sum = np.zeros((patches.shape[0],
                                                patch_size[0] * patch_size[1]))
                    
                    ''' flow mag sum all '''
                    feature_flow_mag_sum_all = np.zeros((patches.shape[0], 1))
                    
                    ''' flow mag of sum of all flow '''
                    feature_flow_sum_all_mag = np.zeros((patches.shape[0], 1))
                    
                    ''' flow ang sum image '''
                    feature_flow_ang_sum = np.zeros((patches.shape[0],
                                                patch_size[0] * patch_size[1]))
                    
                    ''' flow ang of sum of all flow '''
                    feature_flow_sum_all_ang = np.zeros((patches.shape[0], 1))

                    # loop through the patches
                    for i, patch in enumerate(patches):
                        
                        col_1, col_2 = np.sort([patch[0], patch[2]])
                    
                        row_1, row_2 = np.sort([patch[1], patch[3]])
                        
                        feature_flow_mag_sum[i, :] = flow_mag_sum[\
                            row_1 : row_2 + 1, col_1 : col_2 + 1].ravel()
                        
                        feature_flow_mag_sum_all[i] = np.sum(flow_mag_sum[\
                            row_1 : row_2 + 1, col_1 : col_2 + 1])
                        
                        feature_flow_sum_all_mag[i] = np.sqrt(\
                            np.sum(x_projection[row_1 : row_2 + 1,
                                         col_1 : col_2 + 1, :]) ** 2 + \
                            np.sum(y_projection[row_1 : row_2 + 1,
                                         col_1 : col_2 + 1, :]) ** 2)
    
                        feature_flow_ang_sum[i, :] = flow_ang_sum[\
                            row_1 : row_2 + 1, col_1 : col_2 + 1].ravel()
                        
                        feature_flow_sum_all_ang[i] = np.arctan2(\
                            np.sum(y_projection[row_1 : row_2 + 1,
                                                col_1 : col_2 + 1, :]),
                            np.sum(x_projection[row_1 : row_2 + 1,
                                         col_1 : col_2 + 1, :]))
    

    
                    # put into the dictionaries
                    info_and_features = [feature_flow_mag_sum,
                                         feature_flow_mag_sum_all,
                                         feature_flow_sum_all_mag,
                                         feature_flow_ang_sum,
                                         feature_flow_sum_all_ang]                
                    
                    for info_or_feature, fdict in zip(info_and_features, fdicts):
                        
                        if (relevant_key) not in fdict.keys():
                            fdict[(relevant_key)] = []
                            fdict[(relevant_key)].append(patches)
                            fdict[(relevant_key)].append(tags)
                        
                        fdict[(relevant_key)].append(info_or_feature)
    
    
              
        else:
            
            print("No more frames")
            
            cap_flow_mag.release()
            cap_flow_ang.release()
                    
            break        
    else:
        
        cap_flow_mag.release()
        cap_flow_ang.release()
    
    
    
    for ftag, fdict in zip(ftags, fdicts):
    
        with open(directory + 'patches_labels_and_subsetagain_' + ftag + \
                  '_Bins_{:d}'.format(bin_size) + \
                  '___' + name + '.data', 'wb') as f:
        
            pickle.dump((fdict), f)
        
    e2 = cv2.getTickCount()
    time = (e2 - e1)/ cv2.getTickFrequency()
    print("Execution time in seconds = ", time)
