# -*- coding: utf-8 -*-
"""
Created on Fri Feb 23 13:19:01 2018

@author: Callie Darsey

testing  get_flow_mag_in_phase_bins()
"""

import pickle
import numpy as np

with open('flow_mag_phase.data', 'rb') as f:
    flow_mag, flow_phase = pickle.load(f)
    
flow_phase[flow_phase > np.pi] = flow_phase[flow_phase > np.pi] - 2 * np.pi

area = flow_mag.shape[0]

cb1 = np.count_nonzero(np.all([flow_phase >= -np.pi/8, flow_phase < np.pi/8], axis=0))
cb2 = np.count_nonzero(np.all([flow_phase >= np.pi/8, flow_phase < 3 * np.pi/8], axis=0))
cb3 = np.count_nonzero(np.all([flow_phase >= 3 *np.pi/8, flow_phase < 5 * np.pi/8], axis=0))
cb4 = np.count_nonzero(np.all([flow_phase >= 5 *np.pi/8, flow_phase < 7 * np.pi/8], axis=0))
cb5 = np.count_nonzero(np.any([np.all([flow_phase >= 7 *np.pi/8, flow_phase <= np.pi], axis=0),
                         np.all([flow_phase < -7 *np.pi/8, flow_phase >= -np.pi], axis=0)], axis=0))
cb6 = np.count_nonzero(np.all([flow_phase >= -7 *np.pi/8, flow_phase < -5*np.pi/8,], axis=0))
cb7 = np.count_nonzero(np.all([flow_phase >= -5 *np.pi/8, flow_phase < -3*np.pi/8,], axis=0))
cb8 = np.count_nonzero(np.all([flow_phase >= -3 *np.pi/8, flow_phase < -np.pi/8,], axis=0))

sb1 = np.sum(flow_mag[np.all([flow_phase >= -np.pi/8, flow_phase < np.pi/8], axis=0)])
sb2 = np.sum(flow_mag[np.all([flow_phase >= np.pi/8, flow_phase < 3 * np.pi/8], axis=0)])
sb3 = np.sum(flow_mag[np.all([flow_phase >= 3 *np.pi/8, flow_phase < 5 * np.pi/8], axis=0)])
sb4 = np.sum(flow_mag[np.all([flow_phase >= 5 *np.pi/8, flow_phase < 7 * np.pi/8], axis=0)])
sb5 = np.sum(flow_mag[np.any([np.all([flow_phase >= 7 *np.pi/8, flow_phase <= np.pi], axis=0),
                        np.all([flow_phase < -7 *np.pi/8, flow_phase >= -np.pi], axis=0)], axis=0)])
sb6 = np.sum(flow_mag[np.all([flow_phase >= -7 *np.pi/8, flow_phase < -5*np.pi/8,], axis=0)])
sb7 = np.sum(flow_mag[np.all([flow_phase >= -5 *np.pi/8, flow_phase < -3*np.pi/8,], axis=0)])
sb8 = np.sum(flow_mag[np.all([flow_phase >= -3 *np.pi/8, flow_phase < -np.pi/8,], axis=0)])

print('area', area)

for cb, sb in zip([cb1, cb2, cb3, cb4, cb5, cb6, cb7, cb8],
                  [sb1, sb2, sb3, sb4, sb5, sb6, sb7, sb8]):
    if cb == 0:
        sb_div_cb = sb
    else:
        sb_div_cb = sb / cb
        
    print('{:7d}, {:9.2f}, {:9.2f}, {:9.2f}\n'.format(cb, sb, sb_div_cb, sb / area))
    
    









