# -*- coding: utf-8 -*-
"""
Created on Mon Apr  9 23:54:54 2018

@author: Callie Darsey

Every 10, do classification in the union regions
"""

import skin_detector_01 as skin_detector
import get_lessened_features_and_save_steps_01 as get
import cv2
import numpy as np
import matplotlib.pyplot as plt
import pickle

# video path
common_path = './video_copies_clips_track/copies_and_clips_facilitator_C/'
specific_path = 'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__200_208/'
video_name = 'MVI_0028_trans__200_208.mp4'

# load union, and the range[a, b) and step
with open(common_path + specific_path + video_name[0:-4] + \
          '_union_masks.data', 'rb') as f:
    
    ten_frame_mask_union = pickle.load(f)
    
# prep window
title = 'display window'
move_window = [0, -30]
cv2.namedWindow(title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
cv2.moveWindow(title, move_window[0], move_window[1])
    
for info in ten_frame_mask_union:
    
    # [a, b) and step and union_mask
    a, b, step, union_mask = info
    
    cv2.imshow(title, union_mask)
    
    cv2.waitKey(0)
    
    opened_union = cv2.morphologyEx(union_mask, cv2.MORPH_OPEN,
                                       np.ones((3,3)), iterations=1)
    
    cv2.imshow(title, opened_union)
    
    cv2.waitKey(0)
    
    cc_union = cv2.connectedComponentsWithStats(opened_union)
    
#    cv2.imshow(title, opened_union)
#    
#    cv2.waitKey(0)    

cv2.destroyAllWindows()
