# -*- coding: utf-8 -*-
"""
Created on Sun May 20 19:17:07 2018

@author: Callie Darsey

video_writing_example
"""

import cv2
import os
import numpy as np


directory ="./wheeler/dataset/STI_Polk_Apr27_D/MVI_0063_trans/"

for content in os.listdir(directory):
    
    if os.path.isfile(directory + content):
        
        if content[-12:] == '.sampled.mp4':
            
            name = content[:-12]
            
            print(name)
            
            break
                                   
cap_frame = cv2.VideoCapture(directory + name + '.sampled.mp4')

cols = int(cap_frame.get(cv2.CAP_PROP_FRAME_WIDTH))
rows = int(cap_frame.get(cv2.CAP_PROP_FRAME_HEIGHT))
    

# videos to write to
fourcc = cv2.VideoWriter_fourcc(*'XVID')

cap_out = cv2.VideoWriter(\
    directory + name + '.out.mp4', fourcc, 1.67, (cols, rows))
print('hello')    


count = -1

segment=45
detections_per_segment = 5
        
while cap_frame.isOpened():
            
    success_flag_frame, frame = cap_frame.read()
            
    if success_flag_frame == True:
        
        count = count + 1

        if (count % (segment / detections_per_segment)) == 0:
            
            #print(count)
            
            rs = np.random.randint(0, rows)
            cs = np.random.randint(0, cols)
            
            re = np.random.randint(rs, rows)
            ce = np.random.randint(cs, cols)
            
            mask = np.zeros_like(frame)
            
            cv2.rectangle(mask, (cs, rs), (ce, re), (255, 255, 255), -1)
            
            #print(mask.shape)
            
            cap_out.write(mask)

                  
    else:
        
        print("No more frames")
        
        cap_frame.release()
        cap_out.release()
                    
        break        

